<?php
/**
* C A T V I Z
* Open Source Content Manager    
*
* Copyright (C) 2003 Joost Horward
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License 
* version 2 as published by the Free Software Foundation.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public License 
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330,
* Boston, MA 02111-1307 USA
* 
*
* @package catviz
* @author Joost Horward <joost@catviz.org>
* $Date: 2005/08/23 20:20:53 $
* $Author: joosth $
* $Log: index.php,v $
* Revision 1.12  2005/08/23 20:20:53  joosth
* Removed form stack
* Store form persistent data in module objects
*
* Revision 1.9  2004/10/10 12:19:17  joosth
* Treat foreign_key_value=0 as foreign_key_value=NULL
*
* Revision 1.8  2004/10/08 22:11:10  joosth
* Friendly (short) URL support
* Commented out timing display
*
* Revision 1.7  2004/09/16 19:20:27  joosth
* Changed to GPL license (instead of LGPL)
* Commented out timing value display
*
* Revision 1.6  2003/07/21 21:33:26  joosth
* *** empty log message ***
*
* Revision 1.5  2003/05/25 22:04:36  joosth
* Set arg_separator.output to &amp; to be XHTML 1.0 compliant.z
* Allow for blank session_path in which case the session path is not set.
*
* Revision 1.4  2003/05/09 22:21:16  joosth
* Added shared boxtemplate object
* Added global variables that represent values in $_REQUEST
*
* Revision 1.3  2003/04/29 20:49:12  joosth
* Added detailed timing info and CVS headers
*
* $Source: /cvsroot/catviz/catviz/index.php,v $
*/

/**
* Helper function to help calculate page generation time
* This function is placed here to assure the purity of
* the measurement.
*/
function getMicroTime(){ 
    list($usec, $sec) = explode(" ",microtime()); 
    return ((float)$usec + (float)$sec); 
}    
$starttime=getMicroTime();

/*
* *** Main program starts here ***
*/

    // for XHTML 1.0 compliance; makes separators &amp; instead of &
    ini_set('arg_separator.output','&amp;');
    // Include the config file an the main class library
    require_once('conf/config.php');
    require_once('lib/catviz_lib.php');
    // timings kept in tm array for analysis
    $tm[0]=getMicroTime();
    // Create the Registry object
	$registry=&new TRegistry();        
    // The catzinfo object stores error/debugging info
    $GLOBALS['catviz_info']=&new TCatvizInfo();
    error_reporting(E_ERROR | E_WARNING | E_PARSE);
    // use our own error handler
    $old_error_handler = set_error_handler("catvizErrorHandler");
    // Get a list of active modules in order of priority in $modulenames[]
    $sql_result=runquery("select module_name from mod_moduleman where module_active order by module_priority");
    while ($row = mysql_fetch_array($sql_result)) {
        $modulenames[]=$row["module_name"];
    }
    $tm[1]=getMicroTime();
    // Include the classfiles for each active module
    foreach ($modulenames as $modulename) {
        require_once("mod/$modulename/php/mod_$modulename.php");
    }
    $tm[2]=getMicroTime();
    // Set up the session. Module is an array that holds the module objects
    if ($session_path){
        session_save_path($session_path);
    }
    session_name("Catviz-Content-Manager");
    session_start();
    
    /*
    * Initialize the box template object. For efficiency reasons this object is shared
    * by all forms
    */
    $filename="themes/$theme/templates/box_template.html";
    $boxtemplate =& new TTemplate($this,$filename);
    
    $filename=FirstExistingFile("themes/$theme/templates/main_box_template.html","themes/$theme/templates/box_template.html");
    $mainboxtemplate =& new TTemplate($this,$filename);
    
    // $module is an array holding the module objects. It needs to be session-persistent
    $module =&$_SESSION['module'];
    
    // Create objects for each module class - if they don't exist yet.
    foreach ($modulenames as $modulename) {
        $GLOBALS['catviz_info']->current_module=$modulename;
        if ($module["mod_$modulename"]==NULL) {
            $classname = "MOD_" . $modulename;
            $module["mod_$modulename"] = &new $classname();
        }
    }
    $pair =each($_GET);
    $pos=strpos($pair['key'],'_form');
    if ($pos>0){
    	$module_name=substr($pair['key'],0,$pos);
    	$form=$pair['value'];
    	$pair=each($_GET);
    	if ($pair) {
    		$action=$pair['key'];
    		$fkey=$pair['value'];
    	}
    	
    	$req_module=$module_name;
    	$req_form_name=$form;
    	$req_form_action=$action;
    	$req_form_new=FALSE;
    	$pair=each($_GET);
    	if ($pair['key']=='opt') {
    		$opt=$pair['value'];
			if (strpos($opt,'n')!==false) $req_form_new=TRUE;    		 
    	}    	
    	$req_operation='form';    	
    	$req_foreign_key_value=$fkey;	
    } else{
    if (in_array($pair['key'],$modulenames)){
    	$req_module=$pair['key'];
    	$req_form_name=$pair['key'];
    	$req_form_action='';
    	$req_form_new=FALSE;
    	$req_operation='form';    	
    	$req_foreign_key_value=$pair['value'];    	    
    }else{
    // Create global variables which represent the request variables.
    $req_module            =$_REQUEST['module'];
    $req_form_name         =$_REQUEST['form_name'];
    $req_form_action       =$_REQUEST['form_action'];
    $req_operation         =$_REQUEST["{$req_module}_op"];
    $req_form_new          =$_REQUEST['form_new'];
    $req_foreign_key_name  =$_REQUEST['foreign_key_name'];
    $req_foreign_key_value =$_REQUEST['foreign_key_value'];
    $req_form_check_value  =$_REQUEST['form_check_value'];
    
    }}
    // TODO This is a quick hack to respond correctly even when a foreign_key_value of 0 is encountered
    if ($req_foreign_key_value=='0') $req_foreign_key_value='';
    
    //default: show default module
    if ($req_module=="") {
        $req_module=$default_module;
        $req_operation='form';
        $req_form_name=$default_form;
        $req_form_action=$default_action;
        $default_page=TRUE;
    } else {
        $default_page=FALSE;
    }
    
    // Call the action method of each module object. In fact only one actually does the
    // Action bit - all others only do their before_action and after_action
    
    // Do the asked action. The module can indicate the next module/form/action
    // to be performed. Continue this until we hit a NULL
    // This mechanism allows for sequences (message after submit for example)
    $tm[3]=getMicroTime();
    do {        
        $returnvalues=array();
        foreach ($modulenames as $modulename) {    
            $GLOBALS['catviz_info']->current_module=$modulename;
            if ($modulename==$req_module) {
                $op=$req_operation;
            } else {
                $op="";
            }
            $before_time=getMicroTime();
            $rv=$module["mod_$modulename"]->action($op);
            $action_time[$modulename]=getMicroTime()-$before_time;
            if ($rv!=NULL) {
                $returnvalues=$rv;
            };
        }
        if ($returnvalues!=NULL){        
            list($req_module,$req_form_name,$req_form_action,$req_foreign_key_value)=$returnvalues;
        }
    } while ($returnvalues!=NULL);
    $tm[4]=getMicroTime();
    // If a non-fatal error occurred the error message is placed in CNT_error
    // and is shown by the templating engine as any other content    
    $GLOBALS['catviz_info']->showErrorMessage();
    
    // Instantiate the layout manager and output the content.
    $modname=$req_module;
    if ($default_page){
        $templatefilename=firstExistingFile("themes/$theme/templates/default_page_template.html","themes/$theme/mod/$modname/templates/default_page_template.html","themes/$theme/mod/$modname/templates/page_template.html","themes/$theme/templates/page_template.html");
    } else {
        $templatefilename=firstExistingFile("themes/$theme/mod/$modname/templates/page_template.html","themes/$theme/templates/page_template.html");
    }
    $layout=&new TPageTemplate($templatefilename);

    $tm[5]=getMicroTime();    
    $layout->clearContent;
    $layout->processPageTemplate();
    $tm[6]=getMicroTime();
    $preptime=$tm[6]-$starttime;
    //print "This page was generated in $preptime seconds";
    //print $layout->getContent();
    echo $layout->getContent();
    
    
    // Save the persistent properties of each form in the module, then erase the form
    // This is essential in order to minimize the session storage requirements
    foreach ($modulenames as $modulename) {
     	foreach ($module["mod_$modulename"]->forms as $aformname =>$aform){
     		if ($aform) {
     			$module["mod_$modulename"]->forms[$aformname]->savePersistentProperties();
     			unset($module["mod_$modulename"]->forms[$aformname]);
     		}
     	}    
    }            
    $endtime=getMicroTime();
    $totaltime=$endtime-$starttime;
    $dt[0]=$tm[0]-$starttime;
    $dt[1]=$tm[1]-$tm[0];
    $dt[2]=$tm[2]-$tm[1];
    $dt[3]=$tm[3]-$tm[2];
    $dt[4]=$tm[4]-$tm[3];
    $dt[5]=$tm[5]-$tm[4];
    $dt[6]=$tm[6]-$tm[5];
    $dt[7]=$endtime-$tm[6];
    // Uncomment the line below for an indication of page generation times
    //printf("<P><small><center>This page was generated in %2.3f seconds.</center></small>",$totaltime);
    //printf("<P><small><center>include libs=%2.3f info/error/modquery=%2.3f include modules=%2.3f session/module objects=%2.3f action=%2.3f layout=%2.3f + %2.3f print=%2.3f</center></small>",$dt[0],$dt[1],$dt[2],$dt[3],$dt[4],$dt[5],$dt[6],$dt[7]);
//    echo "<P><small><center>Module action times: ";
  //  foreach ($action_time as $amodule=>$atime) { printf ("%s=%2.3f - ",$amodule,$atime);}
//    echo '</small></center>'; 
    // Display the number of modules and forms
    $num_modules=count($module);
    foreach ($modulenames as $modulename){
        $theforms=&$module["mod_$modulename"]->forms;
       // foreach ($theforms as $form_name=>$form) { print ("<small><br />$modulename - $form_name</small>");}
        $num_forms += count($theforms);
    }
   //print("<P><small><center> $num_modules modules, $num_forms forms</center></small>");    
   //print_r ($_SESSION);
   //print ($module['mod_webpages']->forms['webpage_edit']->fields['title']->title);
   //foreach ($module['mod_news']->forms['news']->fields as $fieldtitle=>$field) print "<br /><b>$fieldtitle</b> {$field->_value}";
    /**/
?>
