## MySQL dump 9.09
##
## Host: localhost    Database: catviz
## ------------------------------------------------------
## Server version	4.0.16

##
## Table structure for table `mod_menu`
##

CREATE TABLE mod_menu (
  menu_id int(11) NOT NULL auto_increment,
  menu_op varchar(32) NOT NULL default '',
  menu_visible tinyint(1) NOT NULL default '0',
  menu_name varchar(32) NOT NULL default '',
  menu_order int(11) NOT NULL default '0',
  menu_item_title varchar(32) NOT NULL default '',
  menu_module varchar(32) NOT NULL default '',
  menu_form varchar(32) NOT NULL default '',
  menu_action varchar(32) NOT NULL default '',
  PRIMARY KEY  (menu_id)
) TYPE=MyISAM;

##
## Dumping data for table `mod_menu`
##

INSERT INTO mod_menu VALUES (1,'form',1,'login',99,'Login','userman','login','edit');
INSERT INTO mod_menu VALUES (2,'logout',0,'logout',99,'Logout','userman','','show');
INSERT INTO mod_menu VALUES (3,'form',1,'controlpanel',50,'Control Panel','moduleman','controlpanel','show');
INSERT INTO mod_menu VALUES (4,'form',1,'news',40,'News','news','news','show');
INSERT INTO mod_menu VALUES (5,'form',1,'phonebook',60,'Phonebook','phonebook','phone_list','show');

##
## Table structure for table `mod_moduleman`
##

CREATE TABLE mod_moduleman (
  module_priority int(11) NOT NULL default '0',
  module_id int(11) NOT NULL auto_increment,
  module_name varchar(25) NOT NULL default '',
  module_title varchar(25) NOT NULL default '',
  module_active tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (module_id)
) TYPE=MyISAM;

##
## Dumping data for table `mod_moduleman`
##

INSERT INTO mod_moduleman VALUES (10,1,'moduleman','Module Manager',1);
INSERT INTO mod_moduleman VALUES (50,2,'userman','User Manager',1);
INSERT INTO mod_moduleman VALUES (50,3,'phonebook','Phone Book',1);
INSERT INTO mod_moduleman VALUES (60,4,'menu','Menu manager',1);
INSERT INTO mod_moduleman VALUES (50,5,'news','News',1);
INSERT INTO mod_moduleman VALUES (50,7,'search','Site Search',1);
INSERT INTO mod_moduleman VALUES (50,8,'approval','Approval',1);
INSERT INTO mod_moduleman VALUES (50,9,'webpages','Web Pages',1);
INSERT INTO mod_moduleman VALUES (50,10,'stats','Statistics',1);
INSERT INTO mod_moduleman VALUES (55,11,'regedit','Registry Editor',1);

##
## Table structure for table `mod_moduleman_access_classes`
##

CREATE TABLE mod_moduleman_access_classes (
  access_class_id int(11) NOT NULL auto_increment,
  module_id int(11) NOT NULL default '0',
  access_class_name varchar(32) NOT NULL default '',
  PRIMARY KEY  (access_class_id)
) TYPE=MyISAM;

##
## Dumping data for table `mod_moduleman_access_classes`
##

INSERT INTO mod_moduleman_access_classes VALUES (1,1,'moduleman_user');
INSERT INTO mod_moduleman_access_classes VALUES (2,1,'moduleman_admin');
INSERT INTO mod_moduleman_access_classes VALUES (3,2,'userman_user');
INSERT INTO mod_moduleman_access_classes VALUES (4,2,'userman_admin');
INSERT INTO mod_moduleman_access_classes VALUES (5,3,'phonebook_user');
INSERT INTO mod_moduleman_access_classes VALUES (6,3,'phonebook_admin');
INSERT INTO mod_moduleman_access_classes VALUES (7,5,'news_user');
INSERT INTO mod_moduleman_access_classes VALUES (8,5,'news_admin');
INSERT INTO mod_moduleman_access_classes VALUES (9,8,'approval_user');
INSERT INTO mod_moduleman_access_classes VALUES (10,8,'approval_admin');
INSERT INTO mod_moduleman_access_classes VALUES (11,9,'webpages_user');
INSERT INTO mod_moduleman_access_classes VALUES (12,9,'webpages_admin');
INSERT INTO mod_moduleman_access_classes VALUES (13,10,'stats_user');
INSERT INTO mod_moduleman_access_classes VALUES (14,10,'stats_admin');
INSERT INTO mod_moduleman_access_classes VALUES (15,11,'regedit_user');
INSERT INTO mod_moduleman_access_classes VALUES (16,11,'regedit_admin');

##
## Table structure for table `mod_news`
##

CREATE TABLE mod_news (
  document_class_id int(11) NOT NULL default '0',
  review_time time NOT NULL default '00:00:00',
  status varchar(10) NOT NULL default '',
  reviewer_user_id int(11) NOT NULL default '0',
  review_date date NOT NULL default '0000-00-00',
  big_image varchar(50) NOT NULL default '',
  active varchar(100) NOT NULL default '',
  small_image varchar(50) NOT NULL default '',
  news_id int(11) NOT NULL auto_increment,
  subject varchar(50) NOT NULL default '',
  summary longtext NOT NULL,
  bodytext longtext NOT NULL,
  creation_date date NOT NULL default '0000-00-00',
  creation_time time NOT NULL default '00:00:00',
  user_id int(11) NOT NULL default '0',
  expiration_date date NOT NULL default '0000-00-00',
  priority int(11) NOT NULL default '0',
  PRIMARY KEY  (news_id)
) TYPE=MyISAM;

##
## Dumping data for table `mod_news`
##


##
## Table structure for table `mod_phonebook`
##

CREATE TABLE mod_phonebook (
  phonebook_id int(11) NOT NULL auto_increment,
  first_name varchar(25) default '',
  last_name varchar(25) default '',
  job_title varchar(25) default '',
  department varchar(25) default '',
  location varchar(25) default '',
  extension varchar(25) default '',
  direct_line varchar(25) default '',
  mobile varchar(25) default '',
  fax varchar(25) default '',
  PRIMARY KEY  (phonebook_id)
) TYPE=MyISAM;

##
## Dumping data for table `mod_phonebook`
##


##
## Table structure for table `mod_stats`
##

CREATE TABLE mod_stats (
  stat_id int(11) NOT NULL auto_increment,
  stat_name varchar(32) NOT NULL default '',
  stat_title varchar(100) NOT NULL default '',
  PRIMARY KEY  (stat_id)
) TYPE=MyISAM;

##
## Dumping data for table `mod_stats`
##

INSERT INTO mod_stats VALUES (1,'site_hits','Number of hits on the site');
INSERT INTO mod_stats VALUES (2,'site_visitors','Number of visitors on the site');

##
## Table structure for table `mod_stats_records`
##

CREATE TABLE mod_stats_records (
  stat_record_date date NOT NULL default '0000-00-00',
  stat_record_id int(11) NOT NULL auto_increment,
  stat_id int(11) NOT NULL default '0',
  stat_record_category varchar(32) NOT NULL default '',
  stat_record_value int(11) NOT NULL default '0',
  PRIMARY KEY  (stat_record_id)
) TYPE=MyISAM;

##
## Dumping data for table `mod_stats_records`
##


##
## Table structure for table `mod_users`
##

CREATE TABLE mod_users (
  user_approval_date varchar(100) NOT NULL default '',
  user_expiry_date date NOT NULL default '0000-00-00',
  user_creation_date varchar(100) NOT NULL default '',
  last_login_date date NOT NULL default '0000-00-00',
  last_login_time time NOT NULL default '00:00:00',
  login_count int(11) NOT NULL default '0',
  failed_login_attempts int(11) NOT NULL default '0',
  user_status varchar(10) NOT NULL default '',
  password varchar(32) NOT NULL default '',
  user_id int(11) NOT NULL auto_increment,
  first_name varchar(25) default '',
  last_name varchar(50) default '',
  email varchar(100) NOT NULL default '',
  username varchar(25) NOT NULL default '',
  admin tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (user_id)
) TYPE=MyISAM;

##
## Dumping data for table `mod_users`
##

INSERT INTO mod_users VALUES ('2004-01-01','2008-01-01','2004-01-01','2004-10-08','23:10:22',0,0,'enabled','6601ae3a4cf8a7045af15622a65bc8f9',1,'Default','Admin','change@this.now','admin',1);

##
## Table structure for table `mod_users_acl`
##

CREATE TABLE mod_users_acl (
  access_class_name varchar(32) NOT NULL default '',
  access_class_id int(11) NOT NULL auto_increment,
  user_id int(11) NOT NULL default '0',
  PRIMARY KEY  (access_class_id)
) TYPE=MyISAM;

##
## Dumping data for table `mod_users_acl`
##


##
## Table structure for table `mod_users_document_class`
##

CREATE TABLE mod_users_document_class (
  document_class_id int(11) NOT NULL auto_increment,
  document_class_name varchar(50) NOT NULL default '',
  PRIMARY KEY  (document_class_id)
) TYPE=MyISAM;

##
## Dumping data for table `mod_users_document_class`
##

INSERT INTO mod_users_document_class VALUES (1,'Public');
INSERT INTO mod_users_document_class VALUES (2,'Block');

##
## Table structure for table `mod_users_group_acl`
##

CREATE TABLE mod_users_group_acl (
  access_class_name varchar(32) NOT NULL default '',
  access_class_id int(11) NOT NULL auto_increment,
  group_id int(11) NOT NULL default '0',
  PRIMARY KEY  (access_class_id)
) TYPE=MyISAM;

##
## Dumping data for table `mod_users_group_acl`
##

INSERT INTO mod_users_group_acl VALUES ('moduleman_user',1,1);
INSERT INTO mod_users_group_acl VALUES ('userman_user',2,1);

##
## Table structure for table `mod_users_group_document_classes`
##

CREATE TABLE mod_users_group_document_classes (
  group_document_class_id int(11) NOT NULL auto_increment,
  document_class_id int(11) NOT NULL default '0',
  group_id int(11) NOT NULL default '0',
  read_access tinyint(1) NOT NULL default '0',
  write_access tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (group_document_class_id)
) TYPE=MyISAM;

##
## Dumping data for table `mod_users_group_document_classes`
##

INSERT INTO mod_users_group_document_classes VALUES (1,2,1,1,0);

##
## Table structure for table `mod_users_groupmember`
##

CREATE TABLE mod_users_groupmember (
  link_id int(11) NOT NULL auto_increment,
  user_id int(11) NOT NULL default '0',
  group_id int(11) NOT NULL default '0',
  PRIMARY KEY  (link_id)
) TYPE=MyISAM;

##
## Dumping data for table `mod_users_groupmember`
##


##
## Table structure for table `mod_users_groups`
##

CREATE TABLE mod_users_groups (
  group_id int(11) NOT NULL auto_increment,
  group_name varchar(25) NOT NULL default '',
  group_description varchar(100) default '',
  PRIMARY KEY  (group_id)
) TYPE=MyISAM;

##
## Dumping data for table `mod_users_groups`
##

INSERT INTO mod_users_groups VALUES (1,'Everyone','This includes everyone. Users need not be in the list.');

##
## Table structure for table `mod_users_user_document_classes`
##

CREATE TABLE mod_users_user_document_classes (
  user_document_class_id int(11) NOT NULL auto_increment,
  user_id int(11) NOT NULL default '0',
  document_class_id int(11) NOT NULL default '0',
  read_access tinyint(1) NOT NULL default '0',
  write_access tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (user_document_class_id)
) TYPE=MyISAM;

##
## Dumping data for table `mod_users_user_document_classes`
##


##
## Table structure for table `mod_webpages`
##

CREATE TABLE mod_webpages (
  url varchar(100) NOT NULL default '',
  content_var varchar(50) NOT NULL default '',
  html mediumtext NOT NULL,
  document_class_id int(11) NOT NULL default '0',
  active tinyint(1) NOT NULL default '0',
  webpage_id int(11) NOT NULL auto_increment,
  parent_id int(11) default '0',
  title varchar(50) NOT NULL default '',
  update_date date NOT NULL default '0000-00-00',
  update_time time NOT NULL default '00:00:00',
  user_id int(11) NOT NULL default '0',
  webpage_name varchar(25) default '',
  PRIMARY KEY  (webpage_id)
) TYPE=MyISAM;

##
## Dumping data for table `mod_webpages`
##

INSERT INTO mod_webpages VALUES ('','CNT_welcome','\r\n<b>Catviz</b> is a PHP/MySQL based content manager. Its primary aim is to provide a rich platform for the development of interactive websites.\r\n                    <p>It is <span class=\"emphasis\"><em>very</em></span> different from any other PHP/MySQL content manager because of the following features:</p>\r\n                    <div class=\"itemizedlist\">\r\n                    <ul type=\"disc\"><li><p>Clean approach, built from the ground up.</p></li>\r\n                    <li><p>Full Object-Oriented approach. Each module is represented by a class (derived from a module skeleton class). Each module contains form objects, which in turn contain field objects etc. The high level of reuseability that results from this approach shows in the small amount of lines needed to code indidivual modules.</p></li>\r\n                    <li><p>Full API documentation, created using Docbook and phpdoc.</p></li>\r\n                    <li><p>Consistent user interface thanks to the OOP approach mentioned above.</p></li>\r\n                    <li><p>Database entry integration. Classes are provided for everything you need to allow database data entry.</p></li>\r\n                    <li><p>Fully integrated security/access control management. Since this is completely embedded in the forms system it needs very little attention from the module author. Access is granted to users and groups on a per-functionality and per-document basis, using Access Classes and Document Classes.</p></li>\r\n                    <li><p>Site Search and centralized Approval functionality.</p></li>\r\n                    <li><p>Very flexible templating system, which integrates nicely with the form classes.</p></li>\r\n                    <li><p>Automated form tracking (the form stack) for navigation purposes.</p></li></ul></div>\r\n                    <p>The functionality currently available is:</p><div class=\"itemizedlist\">\r\n                    <ul type=\"disc\"><li><p>Class library</p></li>\r\n                    <li><p>Module manager</p></li><li><p>Menu manager</p></li>\r\n                    <li><p>User manager</p></li><li><p>News</p></li><li><p>Site Search</p></li>\r\n                    <li><p>Approval</p></li>\r\n                    <li><p>Phonebook</p></li><li><p>Static Webpages with Tree index</p></li></ul></div>\r\n<p>Catviz uses some excellent work of others:</p>\r\n                        <p>The TDateField uses Mihai Bazon\'s JavaScript DHTML pop-up calendar (from <a href=\"http://students.infoiasi.ro/~mishoo/site/calendar.epl\">students.infoiasi.ro/~mishoo/site/calendar.epl</a>).</p>\r\n<p>The Treeview Javascript is a package called dTree created by Geir Landr? (<a href=\"http://www.destroydrop.com/javascript/tree/\">www.destroydrop.com/javascript/tree</a>)</p>\r\n\r\n\r\n                        <p>The penguin icon graphics in the Aqua team created by  Everaldo Coelho (<a href=\"http://www.everaldo.com\">www.everaldo.com</a>)</p>\r\n                        <p />\r\n                        <p>Enjoy!</p>\r\n<p> <img alt=\"J:)st\" src=\"var/mod/webpages/file/3ec002d874266_mini-joost.png\" /></p>\r\n',1,1,22,24,'Welcome to Catviz!','2004-10-08','23:11:47',1,'about');
INSERT INTO mod_webpages VALUES ('','','\r\nThis section contains documentation about Catviz.',1,1,25,0,'About Catviz','2004-10-08','23:12:02',1,'');
INSERT INTO mod_webpages VALUES ('','','This groups the block forms. It is inactive so that it is shown to admins only in the tree view',1,0,24,0,'Blocks','2003-05-11','10:56:53',1,'');
INSERT INTO mod_webpages VALUES ('','','<div class=\"article\" lang=\"en\" xml:lang=\"en\">\r\n<div class=\"titlepage\">\r\n<div>\r\n<div>\r\n<h1 class=\"title\"><a name=\"d0e1\" id=\"d0e1\"></a>Catviz Manual</h1>\r\n</div>\r\n<div>\r\n<h3 class=\"corpauthor\">Joost Horward</h3>\r\n</div>\r\n</div>\r\n<hr /></div>\r\n<div class=\"toc\">\r\n<dl>\r\n<dt>1. <a href=\"#d0e9\">Introduction</a></dt>\r\n<dd>\r\n<dl>\r\n<dt>1.1. <a href=\"#d0e28\">Credits</a></dt>\r\n<dt>1.2. <a href=\"#d0e47\">Overview</a></dt>\r\n</dl>\r\n</dd>\r\n<dt>2. <a href=\"#d0e118\">Installing Catviz</a></dt>\r\n<dd>\r\n<dl>\r\n<dt>2.1. <a href=\"#d0e128\">Requirements</a></dt>\r\n<dt>2.2. <a href=\"#d0e133\">Installation</a></dt>\r\n</dl>\r\n</dd>\r\n<dt>3. <a href=\"#d0e138\">Using Catviz</a></dt>\r\n<dd>\r\n<dl>\r\n<dt>3.1. <a href=\"#d0e146\">The control panel</a></dt>\r\n<dt>3.2. <a href=\"#d0e153\">The Module Manager</a></dt>\r\n<dt>3.3. <a href=\"#d0e161\">The User Administrator</a></dt>\r\n<dt>3.4. <a href=\"#d0e238\">The News List Administrator</a></dt>\r\n<dt>3.5. <a href=\"#d0e243\">The Approval Administrator</a></dt>\r\n<dt>3.6. <a href=\"#d0e248\">The Webpages Administrator</a></dt>\r\n<dt>3.7. <a href=\"#d0e253\">The Menu Administrator</a></dt>\r\n</dl>\r\n</dd>\r\n<dt>4. <a href=\"#d0e258\">Understanding Catviz</a></dt>\r\n<dd>\r\n<dl>\r\n<dt>4.1. <a href=\"#d0e261\">Architecture</a></dt>\r\n<dt>4.2. <a href=\"#d0e268\">Execution flow</a></dt>\r\n<dt>4.3. <a href=\"#d0e273\">Calling a form</a></dt>\r\n<dt>4.4. <a href=\"#d0e315\">Database</a></dt>\r\n<dt>4.5. <a href=\"#d0e322\">Security</a></dt>\r\n<dd>\r\n<dl>\r\n<dt>4.5.1. <a href=\"#d0e327\">The user manager</a></dt>\r\n<dt>4.5.2. <a href=\"#d0e332\">The forms access control\r\nsystem</a></dt>\r\n<dt>4.5.3. <a href=\"#d0e337\">The document access control\r\nsystem</a></dt>\r\n</dl>\r\n</dd>\r\n<dt>4.6. <a href=\"#d0e350\">The Template System</a></dt>\r\n<dd>\r\n<dl>\r\n<dt>4.6.1. <a href=\"#d0e355\">Page Template</a></dt>\r\n<dt>4.6.2. <a href=\"#d0e368\">Box Template</a></dt>\r\n<dt>4.6.3. <a href=\"#d0e412\">Form Templates</a></dt>\r\n</dl>\r\n</dd>\r\n</dl>\r\n</dd>\r\n<dt>5. <a href=\"#d0e426\">Writing a Catviz module</a></dt>\r\n<dd>\r\n<dl>\r\n<dt>5.1. <a href=\"#d0e430\">File structure of a module</a></dt>\r\n<dt>5.2. <a href=\"#d0e466\">Coding Standard</a></dt>\r\n<dt>5.3. <a href=\"#d0e487\">Coding the module</a></dt>\r\n<dd>\r\n<dl>\r\n<dt>5.3.1. <a href=\"#d0e492\">TModule</a></dt>\r\n<dt>5.3.2. <a href=\"#d0e512\">TForm</a></dt>\r\n</dl>\r\n</dd>\r\n</dl>\r\n</dd>\r\n<dt>6. <a href=\"#d0e520\">Modules in the Catviz package</a></dt>\r\n<dd>\r\n<dl>\r\n<dt>6.1. <a href=\"#d0e524\">The Webpages module</a></dt>\r\n</dl>\r\n</dd>\r\n</dl>\r\n</div>\r\n<div class=\"sect1\" lang=\"en\" xml:lang=\"en\">\r\n<div class=\"titlepage\">\r\n<div>\r\n<div>\r\n<h2 class=\"title\" style=\"clear: both\"><a name=\"d0e9\" id=\r\n\"d0e9\"></a>1.&nbsp;Introduction</h2>\r\n</div>\r\n</div>\r\n</div>\r\n<p>Welcome to catviz. I am very excited about this release,\r\nand I hope you like it. I would really like to receive feedback.\r\nPlease leave a message at <a href=\"http://www.catviz.org\" target=\r\n\"_top\">www.catviz.org</a>. You can email me at <tt class=\r\n\"email\">&lt;<a href=\r\n\"mailto:joost@catviz.org\">joost@catviz.org</a>&gt;</tt></p>\r\n<p>This is the Catviz administrator and developer documentation.\r\nThe class library is documented by phpdoc (<a href=\r\n\"http://www.phpdoc.org\" target=\"_top\"></a><a href=\"#\"></a><a href=\r\n\"http://www.phpdoc.org\" target=\"_top\">www.phpdoc.org</a>). The\r\nresult is available <a href=\r\n\"http://www.catviz.org/doc/phpdoc/index.html\" target=\r\n\"_top\">here</a></p>\r\n<div class=\"sect2\" lang=\"en\" xml:lang=\"en\">\r\n<div class=\"titlepage\">\r\n<div>\r\n<div>\r\n<h3 class=\"title\"><a name=\"d0e28\" id=\r\n\"d0e28\"></a>1.1.&nbsp;Credits</h3>\r\n</div>\r\n</div>\r\n</div>\r\n<p>The TDateField uses Mihai Bazon\'s excellent JavaScript DHTML\r\npop-up calendar (from <a href=\r\n\"http://students.infoiasi.ro/~mishoo/site/calendar.epl\" target=\r\n\"_top\">students.infoiasi.ro/~mishoo/site/calendar.epl</a>).</p>\r\n<p>The penguin icon graphics in the Aqua team are the excellent\r\nwork of Everaldo Coelho (<a href=\"http://www.everaldo.com\" target=\r\n\"_top\">www.everaldo.com</a>)</p>\r\n<p>The Treeview Javascript is a package called dTree which is the\r\nexcellent work of Geir Landr&ouml; (<a href=\"???\" target=\r\n\"_top\">www.destroydrop.com/javascript/tree/)</a></p>\r\n<p>Although Catviz is a newly built content manager phpWebSite has\r\nbeen an inspiration in many ways. Without my previous experience\r\nwith phpWebSite Catviz would not be what it is today.</p>\r\n</div>\r\n<div class=\"sect2\" lang=\"en\" xml:lang=\"en\">\r\n<div class=\"titlepage\">\r\n<div>\r\n<div>\r\n<h3 class=\"title\"><a name=\"d0e47\" id=\r\n\"d0e47\"></a>1.2.&nbsp;Overview</h3>\r\n</div>\r\n</div>\r\n</div>\r\n<p>Catviz is a PHP/MySQL based content manager. Its primary aim is\r\nto provide a rich platform for the development of interactive\r\nwebsites.</p>\r\n<p>It is <span class=\"emphasis\"><em>very</em></span> different from\r\nany other PHP/MySQL content manager because of the following\r\nfeatures:</p>\r\n<div class=\"itemizedlist\">\r\n<ul type=\"disc\">\r\n<li>\r\n<p>Clean approach, built from the ground up.</p>\r\n</li>\r\n<li>\r\n<p>Full Object-Oriented approach. Each module is represented by a\r\nclass (derived from a module skeleton class). Each module contains\r\nform objects, which in turn contain field objects etc. The high\r\nlevel of reuseability that results from this approach shows in the\r\nsmall amount of lines needed to code indidivual modules.</p>\r\n</li>\r\n<li>\r\n<p>Full API documentation, created using Docbook and phpdoc.</p>\r\n</li>\r\n<li>\r\n<p>Consistent user interface thanks to the OOP approach mentioned\r\nabove.</p>\r\n</li>\r\n<li>\r\n<p>Database entry integration. Classes are provided for everything\r\nyou need to allow database data entry.</p>\r\n</li>\r\n<li>\r\n<p>Fully integrated security/access control management. Since this\r\nis completely embedded in the forms system it needs very little\r\nattention from the module author. Access is granted to users and\r\ngroups on a per-functionality and per-document basis, using Access\r\nClasses and Document Classes.</p>\r\n</li>\r\n<li>\r\n<p>Site Search facility</p>\r\n</li>\r\n<li>\r\n<p>Centralized Approval facility</p>\r\n</li>\r\n<li>\r\n<p>Very flexible templating system, which integrates nicely with\r\nthe form classes.</p>\r\n</li>\r\n<li>\r\n<p>Automated form tracking (the form stack) for navigation\r\npurposes.</p>\r\n</li>\r\n</ul>\r\n</div>\r\n<p>The functionality currently available is:</p>\r\n<div class=\"itemizedlist\">\r\n<ul type=\"disc\">\r\n<li>\r\n<p>Class library</p>\r\n</li>\r\n<li>\r\n<p>Module manager</p>\r\n</li>\r\n<li>\r\n<p>Menu manager</p>\r\n</li>\r\n<li>\r\n<p>User manager</p>\r\n</li>\r\n<li>\r\n<p>News</p>\r\n</li>\r\n<li>\r\n<p>Site Search</p>\r\n</li>\r\n<li>\r\n<p>Approval</p>\r\n</li>\r\n<li>\r\n<p>Phonebook</p>\r\n</li>\r\n<li>\r\n<p>Static web pages with tree index</p>\r\n</li>\r\n</ul>\r\n</div>\r\n</div>\r\n</div>\r\n<div class=\"sect1\" lang=\"en\" xml:lang=\"en\">\r\n<div class=\"titlepage\">\r\n<div>\r\n<div>\r\n<h2 class=\"title\" style=\"clear: both\"><a name=\"d0e118\" id=\r\n\"d0e118\"></a>2.&nbsp;Installing Catviz</h2>\r\n</div>\r\n</div>\r\n</div>\r\n<p>Installation is pretty straightforward. All settings are in\r\nconf/config.php. Check all settings in this filer and point your\r\nbrowser at [yoursite]/install/install.php. Check the settings shown\r\nclick to continue.</p>\r\n<p>Catviz is now installed. One user account is created admin with\r\npassword catviz. Change the password <span class=\r\n\"emphasis\"><em>NOW</em></span>.</p>\r\n<div class=\"sect2\" lang=\"en\" xml:lang=\"en\">\r\n<div class=\"titlepage\">\r\n<div>\r\n<div>\r\n<h3 class=\"title\"><a name=\"d0e128\" id=\r\n\"d0e128\"></a>2.1.&nbsp;Requirements</h3>\r\n</div>\r\n</div>\r\n</div>\r\n<p>Catviz is developed on a RedHat 8 system with Apache 2.0.40, PHP\r\n4.2.2 and MySQL 3.23.52. I would recommend to switch\r\nregister_globals off for security\'s sake. There are no external\r\nrequirements.</p>\r\n</div>\r\n<div class=\"sect2\" lang=\"en\" xml:lang=\"en\">\r\n<div class=\"titlepage\">\r\n<div>\r\n<div>\r\n<h3 class=\"title\"><a name=\"d0e133\" id=\r\n\"d0e133\"></a>2.2.&nbsp;Installation</h3>\r\n</div>\r\n</div>\r\n</div>\r\n<p>Installation is pretty straightforward. All settings are in\r\nconf/config.php. Check all settings in this file and point your\r\nbrowser at [yoursite]/install/install.php. This creates the\r\ndatabase for you. Make sure the var/ tree is writeable by the web\r\nserver (e.g. the \'apache\' or \'http\' user)</p>\r\n</div>\r\n</div>\r\n<div class=\"sect1\" lang=\"en\" xml:lang=\"en\">\r\n<div class=\"titlepage\">\r\n<div>\r\n<div>\r\n<h2 class=\"title\" style=\"clear: both\"><a name=\"d0e138\" id=\r\n\"d0e138\"></a>3.&nbsp;Using Catviz</h2>\r\n</div>\r\n</div>\r\n</div>\r\n<p>Catviz has one interface which is shared by all users. Extra\r\nfeatures appear in the menus depending on your rights. Typically,\r\nafter logging in you will see a menu like this:</p>\r\n<div class=\"screenshot\">\r\n<div><img src=\"menu-screenshot.png\" alt=\"Menu Screenshot\" /></div>\r\n</div>\r\n<div class=\"sect2\" lang=\"en\" xml:lang=\"en\">\r\n<div class=\"titlepage\">\r\n<div>\r\n<div>\r\n<h3 class=\"title\"><a name=\"d0e146\" id=\"d0e146\"></a>3.1.&nbsp;The\r\ncontrol panel</h3>\r\n</div>\r\n</div>\r\n</div>\r\n<p>The control panel gives access to the administrative functions\r\nof each module. A subset of modules may show up depending on your\r\naccess rights. A typical one is shown below:</p>\r\n<div class=\"screenshot\">\r\n<div><img src=\"controlpanel-screenshot.png\" alt=\"Controlpanel Screenshot\" /></div>\r\n</div>\r\n</div>\r\n<div class=\"sect2\" lang=\"en\" xml:lang=\"en\">\r\n<div class=\"titlepage\">\r\n<div>\r\n<div>\r\n<h3 class=\"title\"><a name=\"d0e153\" id=\"d0e153\"></a>3.2.&nbsp;The\r\nModule Manager</h3>\r\n</div>\r\n</div>\r\n</div>\r\n<p>The module manager allows switching modules on and off, as well\r\nas installing new modules. The Module Priority allows you to\r\ndetermine the order in which module is loaded/instantiated. The\r\nmodule manager needs to be the first one - The menu module needs to\r\nbe loaded <span class=\"emphasis\"><em>after</em></span> all the\r\nmodules it refers to are loaded. Each module has a set of Access\r\nClasses which are used for the security system.</p>\r\n</div>\r\n<div class=\"sect2\" lang=\"en\" xml:lang=\"en\">\r\n<div class=\"titlepage\">\r\n<div>\r\n<div>\r\n<h3 class=\"title\"><a name=\"d0e161\" id=\"d0e161\"></a>3.3.&nbsp;The\r\nUser Administrator</h3>\r\n</div>\r\n</div>\r\n</div>\r\n<p>Each user has to be entered through this interface, there is no\r\nself-signup procedure yet. Each user is automatically a member of\r\n\'Everyone\' (once logged in), you don\'t need to make users a member\r\nexplicitly. The user administrator is also used to define document\r\nclasses., see the security section below. Each module defines a set\r\nof access classes. The ones that are curently present are:</p>\r\n<div class=\"table\"><a name=\"d0e167\" id=\"d0e167\"></a>\r\n<p class=\"title\"><b>Table&nbsp;1.&nbsp;Acess Classes overview per\r\nmodule</b></p>\r\n<table summary=\"Acess Classes overview per module\" border=\"1\">\r\n<colgroup>\r\n<col />\r\n<col />\r\n<col /></colgroup>\r\n<tbody>\r\n<tr>\r\n<td><span class=\"emphasis\"><em>Module</em></span></td>\r\n<td><span class=\"emphasis\"><em>user\r\n(modulename_user)</em></span></td>\r\n<td><span class=\"emphasis\"><em>admin\r\n(modulename_admin)</em></span></td>\r\n</tr>\r\n<tr>\r\n<td>Module Manager</td>\r\n<td>Show controlpanel</td>\r\n<td>Add/remove/modify modules</td>\r\n</tr>\r\n<tr>\r\n<td>User Admin</td>\r\n<td>-</td>\r\n<td>Add/remove/modify users</td>\r\n</tr>\r\n<tr>\r\n<td>News</td>\r\n<td>Submit new article</td>\r\n<td>Approve, edit,delete,create articles</td>\r\n</tr>\r\n<tr>\r\n<td>Approval</td>\r\n<td>Approval list</td>\r\n<td>Approval list</td>\r\n</tr>\r\n<tr>\r\n<td>Webpage</td>\r\n<td>Create root webpage</td>\r\n<td>Add/remove/modify webpages</td>\r\n</tr>\r\n<tr>\r\n<td>Menu</td>\r\n<td>-</td>\r\n<td>Add/remove/modify menu items</td>\r\n</tr>\r\n<tr>\r\n<td>Phonebook</td>\r\n<td>Show phonebook</td>\r\n<td>Add/remove/modify phonebook items</td>\r\n</tr>\r\n<tr>\r\n<td>Search</td>\r\n<td>N/A</td>\r\n<td>N/A</td>\r\n</tr>\r\n</tbody>\r\n</table>\r\n</div>\r\n</div>\r\n<div class=\"sect2\" lang=\"en\" xml:lang=\"en\">\r\n<div class=\"titlepage\">\r\n<div>\r\n<div>\r\n<h3 class=\"title\"><a name=\"d0e238\" id=\"d0e238\"></a>3.4.&nbsp;The\r\nNews List Administrator</h3>\r\n</div>\r\n</div>\r\n</div>\r\n<p>This simply shows a full list of news articles, regardless of\r\ntheir status, allowing the News admin to edit ore delete them.</p>\r\n</div>\r\n<div class=\"sect2\" lang=\"en\" xml:lang=\"en\">\r\n<div class=\"titlepage\">\r\n<div>\r\n<div>\r\n<h3 class=\"title\"><a name=\"d0e243\" id=\"d0e243\"></a>3.5.&nbsp;The\r\nApproval Administrator</h3>\r\n</div>\r\n</div>\r\n</div>\r\n<p>The approval administrator collects items to be approved from\r\nall modules, and shows the resulting overview. Click on each item\r\nto show a form which allows the content to be approved or rejected.\r\nThis form is different per module as each module delivers it\'s own\r\ninerface.</p>\r\n</div>\r\n<div class=\"sect2\" lang=\"en\" xml:lang=\"en\">\r\n<div class=\"titlepage\">\r\n<div>\r\n<div>\r\n<h3 class=\"title\"><a name=\"d0e248\" id=\"d0e248\"></a>3.6.&nbsp;The\r\nWebpages Administrator</h3>\r\n</div>\r\n</div>\r\n</div>\r\n<p>The webpages administrator shows a full list of the webpages,\r\nallowing the webpages admin to edit or delete them. Alternatively,\r\nyou may use the edit icon whis is shown in the title bar of the\r\nwebpage when you have edit rights on the page shown. You can\r\nprepare a webpage offline and paste it in here. When you are using\r\nimages, put them in the same directory as your HTML document and\r\nupload them (in the file list). The filenames will be automatically\r\ncorrected in your webpage to show up correctly in Catviz.</p>\r\n</div>\r\n<div class=\"sect2\" lang=\"en\" xml:lang=\"en\">\r\n<div class=\"titlepage\">\r\n<div>\r\n<div>\r\n<h3 class=\"title\"><a name=\"d0e253\" id=\"d0e253\"></a>3.7.&nbsp;The\r\nMenu Administrator</h3>\r\n</div>\r\n</div>\r\n</div>\r\n<p>The module administrator shows a list of menu items. You can\r\nadd/edit/remove these items. Some items are not shown by default\r\nbut activated by the corresponding module. When your menu item\r\npoints at a form, Catviz checks if you have the appropriate rights,\r\nand does not show the menu item if this is not the case.</p>\r\n</div>\r\n</div>\r\n<div class=\"sect1\" lang=\"en\" xml:lang=\"en\">\r\n<div class=\"titlepage\">\r\n<div>\r\n<div>\r\n<h2 class=\"title\" style=\"clear: both\"><a name=\"d0e258\" id=\r\n\"d0e258\"></a>4.&nbsp;Understanding Catviz</h2>\r\n</div>\r\n</div>\r\n</div>\r\n<div class=\"sect2\" lang=\"en\" xml:lang=\"en\">\r\n<div class=\"titlepage\">\r\n<div>\r\n<div>\r\n<h3 class=\"title\"><a name=\"d0e261\" id=\r\n\"d0e261\"></a>4.1.&nbsp;Architecture</h3>\r\n</div>\r\n</div>\r\n</div>\r\n<p>Catviz consists of a class library (catviz_lib.php), a small\r\ncore module controller (index.php), a set of modules which provide\r\nthe standard functionality, and a set of templates. Each module is\r\nrepresented by a class that is a descendant of TModule. Each module\r\ncontains forms (TForm descendants) and fields (TField\r\ndescendants).</p>\r\n<p>The content of each form is mapped on a content variable. A\r\ntemplate determines where each content variable is placed on the\r\ngenerated page.</p>\r\n</div>\r\n<div class=\"sect2\" lang=\"en\" xml:lang=\"en\">\r\n<div class=\"titlepage\">\r\n<div>\r\n<div>\r\n<h3 class=\"title\"><a name=\"d0e268\" id=\r\n\"d0e268\"></a>4.2.&nbsp;Execution flow</h3>\r\n</div>\r\n</div>\r\n</div>\r\n<p>When a connection is made to a Catviz server the first time, a\r\nsession is created (Catviz-Content-Manager). The session store\r\ncontains a formstack, the catviz_info object and a an array of\r\nmodule objects. In each module the \'static\' forms are created and\r\neach \'static\' form is instantiated as an object in the module\r\nobject (this is repeated each time a user logs in our out). Then,\r\nthe action method of each module is called, and finally the layout\r\nmanager creates the page to be shown. Most forms are generated on\r\nthe fly to speed up the initial connection and to minimize the\r\nsession store space usage.</p>\r\n</div>\r\n<div class=\"sect2\" lang=\"en\" xml:lang=\"en\">\r\n<div class=\"titlepage\">\r\n<div>\r\n<div>\r\n<h3 class=\"title\"><a name=\"d0e273\" id=\r\n\"d0e273\"></a>4.3.&nbsp;Calling a form</h3>\r\n</div>\r\n</div>\r\n</div>\r\n<p>Each form is uniquely identified by the combination of\r\nmodulename and formname. Each form has a number of actions it can\r\nperform, such as \'edit\', \'show\', \'submit\'. To show a particular\r\nform the following parameters are needed:</p>\r\n<div class=\"table\"><a name=\"d0e278\" id=\"d0e278\"></a>\r\n<p class=\"title\"><b>Table&nbsp;2.&nbsp;</b></p>\r\n<table summary=\"\" border=\"1\">\r\n<colgroup>\r\n<col />\r\n<col /></colgroup>\r\n<tbody>\r\n<tr>\r\n<td><span class=\"emphasis\"><em>Parameter</em></span></td>\r\n<td><span class=\"emphasis\"><em>Description</em></span></td>\r\n</tr>\r\n<tr>\r\n<td>module</td>\r\n<td>The name of the module</td>\r\n</tr>\r\n<tr>\r\n<td>[modulename]_op</td>\r\n<td>The operation, usually \'form\'</td>\r\n</tr>\r\n<tr>\r\n<td>form_name</td>\r\n<td>The name of the form</td>\r\n</tr>\r\n<tr>\r\n<td>form_action</td>\r\n<td>The action (edit, show, submit,...)</td>\r\n</tr>\r\n<tr>\r\n<td>foreign_key_value</td>\r\n<td>Foreign key (database forms only)</td>\r\n</tr>\r\n</tbody>\r\n</table>\r\n</div>\r\n</div>\r\n<div class=\"sect2\" lang=\"en\" xml:lang=\"en\">\r\n<div class=\"titlepage\">\r\n<div>\r\n<div>\r\n<h3 class=\"title\"><a name=\"d0e315\" id=\r\n\"d0e315\"></a>4.4.&nbsp;Database</h3>\r\n</div>\r\n</div>\r\n</div>\r\n<p>The database ineraction requires a few things in the database\r\ndesign. A unique identifier is needed for each row in each table,\r\nand that identifier needs to be numeric and auto incrementing. The\r\nname is something_id (that\'st not a system requirement but a naming\r\nconvention). Foreign keys in tables need to be named after their\r\nkeyfields in the master table for the master/details views to\r\noperate properly.</p>\r\n<p>Tables for modules are named mod_modulename_... toa avoid\r\ncollisions of tablenames between modules.</p>\r\n</div>\r\n<div class=\"sect2\" lang=\"en\" xml:lang=\"en\">\r\n<div class=\"titlepage\">\r\n<div>\r\n<div>\r\n<h3 class=\"title\"><a name=\"d0e322\" id=\r\n\"d0e322\"></a>4.5.&nbsp;Security</h3>\r\n</div>\r\n</div>\r\n</div>\r\n<p>The security system consists of 3 parts: the user manager, the\r\nforms access control and the data access control.</p>\r\n<div class=\"sect3\" lang=\"en\" xml:lang=\"en\">\r\n<div class=\"titlepage\">\r\n<div>\r\n<div>\r\n<h4 class=\"title\"><a name=\"d0e327\" id=\"d0e327\"></a>4.5.1.&nbsp;The\r\nuser manager</h4>\r\n</div>\r\n</div>\r\n</div>\r\n<p>The usermanager is responsibe for usernames, login, groups,\r\n&amp; encrypted passwords A user can be member of any number or\r\nmore groups. Each user gets a number of access controls assigned\r\nwhich determine the access to the forms. You can think of an access\r\ncontrol as an abstract user group such as news admin, news user\r\netc.</p>\r\n</div>\r\n<div class=\"sect3\" lang=\"en\" xml:lang=\"en\">\r\n<div class=\"titlepage\">\r\n<div>\r\n<div>\r\n<h4 class=\"title\"><a name=\"d0e332\" id=\"d0e332\"></a>4.5.2.&nbsp;The\r\nforms access control system</h4>\r\n</div>\r\n</div>\r\n</div>\r\n<p>The forms access control system consists of a list of access\r\ncontrols which is attached to each form. These controls have flags\r\n(read/write) that determine which type of access is granted to the\r\nowner of that control. For example, a news approval form would have\r\nnews_admin read/write and news_user read only set. Why this\r\ncomplication and why not assigned form rights to user groups\r\nstraightaway? you might ask. The reason is simple,. if I would do\r\nthat I would dictate how user groups are used, and the system would\r\nquickly become cumbersome to use. Now, you set up the groups the\r\nway that is most appropriate for your web/inranetsite and\r\norganization and after that assign users to organisational\r\ngroups.</p>\r\n</div>\r\n<div class=\"sect3\" lang=\"en\" xml:lang=\"en\">\r\n<div class=\"titlepage\">\r\n<div>\r\n<div>\r\n<h4 class=\"title\"><a name=\"d0e337\" id=\"d0e337\"></a>4.5.3.&nbsp;The\r\ndocument access control system</h4>\r\n</div>\r\n</div>\r\n</div>\r\n<p>The document access control system is similar to the forms\r\naccess control. Each document (a web page, a news article) has a\r\ndocument class assigned. A document class is an abstraction for a\r\ngroup of documents that share a common set of access\r\ncharacteristics. Possible Document classes are \"Product\r\nspecification\", \"Software Development Internal\", \"Commercial\", \"HR\r\nPublic\", \"HR Internal\" etc. etc.</p>\r\n<p>Each user or user group gets document classes assigned along\r\nwith access rights read and write.</p>\r\n<p>This way, determining access rights for a document is a one-step\r\nprocess so a document author does not need to consider\r\norganisational impact - that is done per document class.</p>\r\n<p>When a user logs in the total set of document classes to which\r\nthe user has accessed is determined (from the user and group\r\nrights) and this information is kept in the session store for fast\r\nreference.</p>\r\n<p>A standard document class \'Public\' is available read-only to\r\nevery user (even anonymous). Write access to the \'Public\' document\r\nclass has to be set in the user manager.</p>\r\n</div>\r\n</div>\r\n<div class=\"sect2\" lang=\"en\" xml:lang=\"en\">\r\n<div class=\"titlepage\">\r\n<div>\r\n<div>\r\n<h3 class=\"title\"><a name=\"d0e350\" id=\"d0e350\"></a>4.6.&nbsp;The\r\nTemplate System</h3>\r\n</div>\r\n</div>\r\n</div>\r\n<p>The templating system is integrated with the forms, so variables\r\ndo not have to be translated and even form methods can be called\r\nfrom the templates. Each template is divided into sections. Each\r\nsection is separated by special formatted HTML comments, to allow\r\nany HTML editor to edit the templates without a problem. Sections\r\nstart with &lt;##&amp;sectionname--&gt; and end with\r\n&lt;--/sectionname--&gt;. Each section is processed in a sequence\r\ndetermined by the form code. So even when you have foorter before\r\nheader for example, header still comes out first. HTML outside the\r\nsection markers is not used at all. You can add HTML outside the\r\ntags if that helps to keep your HTML editor happy. Inside each\r\nsection form elements are placed using curly brackets around\r\nfieldnames, like:{fieldname}. Methods of the form class and\r\nvariables in the form object can be called using {!functionname()}\r\nor {!variablename} These are evaluated as the form is generated.\r\nThe form definition file is read at form creation time, split into\r\nsections and stored in the session store. This way\r\nre-interpretation is prevented. As a consequence, When you change a\r\ntemplate it will only take effect when the forms are re-initialized\r\n(log in as other user, drop session). There are 3 levels of\r\ntemplates: the page template, the box template and the form\r\ntemplate.</p>\r\n<div class=\"sect3\" lang=\"en\" xml:lang=\"en\">\r\n<div class=\"titlepage\">\r\n<div>\r\n<div>\r\n<h4 class=\"title\"><a name=\"d0e355\" id=\"d0e355\"></a>4.6.1.&nbsp;Page\r\nTemplate</h4>\r\n</div>\r\n</div>\r\n</div>\r\n<p>The page template is an odd one, it holds the template for the\r\npage. in curly brackets are the content variable names rather than\r\nthe fieldnames. There are no zones. The page template is called\r\npage_template.html and is searched for in the following\r\nlocations:</p>\r\n<p><tt class=\r\n\"filename\">themes/[themename]/mod/[modulename]/templates/page_template.html</tt></p>\r\n<p><tt class=\r\n\"filename\">themes/[themename]/templates/page_template.html</tt></p>\r\n<p>The first one found is used. This mechanism allows each module\r\nto have its own page layout when the module has focus.</p>\r\n</div>\r\n<div class=\"sect3\" lang=\"en\" xml:lang=\"en\">\r\n<div class=\"titlepage\">\r\n<div>\r\n<div>\r\n<h4 class=\"title\"><a name=\"d0e368\" id=\"d0e368\"></a>4.6.2.&nbsp;Box\r\nTemplate</h4>\r\n</div>\r\n</div>\r\n</div>\r\n<p>The box template determines the looks of each box (the table\r\nsurrounding each form). It has three sections: header,body and\r\nfooter. The default box uses the following tags to obtain\r\ninformation from the form:</p>\r\n<div class=\"table\"><a name=\"d0e373\" id=\"d0e373\"></a>\r\n<p class=\"title\"><b>Table&nbsp;3.&nbsp;</b></p>\r\n<table summary=\"\" border=\"1\">\r\n<colgroup>\r\n<col />\r\n<col /></colgroup>\r\n<tbody>\r\n<tr>\r\n<td>{!getNavBar()}</td>\r\n<td>gets the content of the navigation bar icons (back, home)</td>\r\n</tr>\r\n<tr>\r\n<td>{!getActionBar()}</td>\r\n<td>gets the content of the navigation bar icons (new etc.)</td>\r\n</tr>\r\n<tr>\r\n<td>{!title}</td>\r\n<td>gets the form title</td>\r\n</tr>\r\n<tr>\r\n<td>{!prologue}</td>\r\n<td>gets the value of $this-&gt;prologue;</td>\r\n</tr>\r\n<tr>\r\n<td>{!content}</td>\r\n<td>gets the value of $this-&gt;content e.g. the form content</td>\r\n</tr>\r\n<tr>\r\n<td>{!epilogue}</td>\r\n<td>gets the value of $this-&gt;epilogue;</td>\r\n</tr>\r\n</tbody>\r\n</table>\r\n</div>\r\n<p>The box template is searched for in the following locations:</p>\r\n<p>themes/[themename]/mod/[modulename]/templates/[formname].html\r\nthemes/[themename]/templates/box-layout.html This allows individual\r\nforms to be independently redesigned.</p>\r\n</div>\r\n<div class=\"sect3\" lang=\"en\" xml:lang=\"en\">\r\n<div class=\"titlepage\">\r\n<div>\r\n<div>\r\n<h4 class=\"title\"><a name=\"d0e412\" id=\"d0e412\"></a>4.6.3.&nbsp;Form\r\nTemplates</h4>\r\n</div>\r\n</div>\r\n</div>\r\n<p>Form templates determine the look of the form (inside of the\r\nbox). Form templates are searched for in the following\r\nlocations:</p>\r\n<p><tt class=\r\n\"filename\">themes/[themename]/mod/[modulename]/templates/[formname].html</tt></p>\r\n<p><tt class=\r\n\"filename\">mod/[modulename]/templates/[formname].html</tt></p>\r\n<p>The Security System The security system consists of 3 parts: the\r\nuser manager, the forms access control and the data access\r\ncontrol.</p>\r\n</div>\r\n</div>\r\n</div>\r\n<div class=\"sect1\" lang=\"en\" xml:lang=\"en\">\r\n<div class=\"titlepage\">\r\n<div>\r\n<div>\r\n<h2 class=\"title\" style=\"clear: both\"><a name=\"d0e426\" id=\r\n\"d0e426\"></a>5.&nbsp;Writing a Catviz module</h2>\r\n</div>\r\n</div>\r\n</div>\r\n<div class=\"sect2\" lang=\"en\" xml:lang=\"en\">\r\n<div class=\"titlepage\">\r\n<div>\r\n<div>\r\n<h3 class=\"title\"><a name=\"d0e430\" id=\"d0e430\"></a>5.1.&nbsp;File\r\nstructure of a module</h3>\r\n</div>\r\n</div>\r\n</div>\r\n<p>Each module lives in a subdirctory under /mod. The following\r\nsubdirectories are present:</p>\r\n<div class=\"variablelist\">\r\n<dl>\r\n<dt><span class=\"term\">php</span></dt>\r\n<dd>\r\n<p>Holds all the files with the actual PHP code</p>\r\n</dd>\r\n<dt><span class=\"term\">doc</span></dt>\r\n<dd>\r\n<p>Holds the documentation for the module</p>\r\n</dd>\r\n<dt><span class=\"term\">img</span></dt>\r\n<dd>\r\n<p>Holds any module-specific image files. Most image files live\r\nwith the theme or in the var area</p>\r\n</dd>\r\n<dt><span class=\"term\">conf</span></dt>\r\n<dd>\r\n<p>Holds the confuiguration file config.php</p>\r\n</dd>\r\n<dt><span class=\"term\">templates</span></dt>\r\n<dd>\r\n<p>Holds all the module specific templates</p>\r\n</dd>\r\n</dl>\r\n</div>\r\n</div>\r\n<div class=\"sect2\" lang=\"en\" xml:lang=\"en\">\r\n<div class=\"titlepage\">\r\n<div>\r\n<div>\r\n<h3 class=\"title\"><a name=\"d0e466\" id=\"d0e466\"></a>5.2.&nbsp;Coding\r\nStandard</h3>\r\n</div>\r\n</div>\r\n</div>\r\n<p>The coding standard used is the standard described in the PEAR\r\ndocumentation with a few additions.</p>\r\n<p>Indents are 4 spaces wide.</p>\r\n<p>Class names are of the form T[Name]. Module class names have the\r\nform MOD_[Name]</p>\r\n<p>Instances of modules (module objects) are named mod_[name]</p>\r\n<p>Class names always start with a capital letter.</p>\r\n<p>Class methods and functions are named using the \'camel\'\r\nconvention, e.g. lowercaseCapitalizedCapitalized.</p>\r\n<p>Attribute names are all lowercase with underscores where\r\nneeded.</p>\r\n<p>Documentation is generated using PHPDocumentor (phpdoc.org). A\r\nsmall reminder for myself what command line is needed: <b class=\r\n\"command\">php phpdoc -t [targetdir] -o HTML:Smarty:default -d\r\n[classdir]</b></p>\r\n</div>\r\n<div class=\"sect2\" lang=\"en\" xml:lang=\"en\">\r\n<div class=\"titlepage\">\r\n<div>\r\n<div>\r\n<h3 class=\"title\"><a name=\"d0e487\" id=\"d0e487\"></a>5.3.&nbsp;Coding\r\nthe module</h3>\r\n</div>\r\n</div>\r\n</div>\r\n<p>The main code lives in php/MOD_[modulename].</p>\r\n<div class=\"sect3\" lang=\"en\" xml:lang=\"en\">\r\n<div class=\"titlepage\">\r\n<div>\r\n<div>\r\n<h4 class=\"title\"><a name=\"d0e492\" id=\r\n\"d0e492\"></a>5.3.1.&nbsp;TModule</h4>\r\n</div>\r\n</div>\r\n</div>\r\n<p>TModule is the baseclass that you can use to derive your module\r\nfrom.</p>\r\n<pre class=\"programlisting\">\r\n<span class=\"application\">class MOD_mymodule extends TModule{\r\n    var ...\r\n\r\n    /**\r\n    * Constructor for the MyModule class\r\n    *\r\n    */\r\n    function MOD_mymodule(){\r\n        TModule::TModule(\"mymodule\");\r\n\r\n    }\r\n\r\n    function initializeForms(){\r\n        Tmodule::InitializeForms();\r\n        .\r\n        .\r\n        .\r\n    }\r\n\r\n    function initializeForm($formname){\r\n        switch ($formname){\r\n            /**\r\n            * Create the Webpage edit form\r\n            */\r\n            case \'webpage_edit\':\r\n            .\r\n            .\r\n        }\r\n    }\r\n\r\n               </span>\r\n</pre>\r\n<p>Add forms in initialzeForms and/or initializeForm. It is\r\nimportant to understand the difference between the two:</p>\r\n<p>InitializeForms is called when a new session is started and\r\nwhenever a new user logs in or out.</p>\r\n<p>IntializeForm($formname) is called when a form is not found in\r\nthe module.</p>\r\n<p>You should always use initializeForm unless you have good\r\nreasons not to. initializeForm helps to create forms just-in-time\r\nand keep the initial connection time short, keeps the memory\r\nrequirements low and the session size small. Initializing forms up\r\nfront in initializeForm only makes sense for \'static\' forms -\r\nusually blocks that are always shown - such as the main menu.</p>\r\n<p>This means that it is safe to determine user rights here and\r\nallow/disallow form access/creation based on that. But any code you\r\nput here is never re-exectuted in a sesion, so this code should not\r\nattempt to respond to any user input.</p>\r\n</div>\r\n<div class=\"sect3\" lang=\"en\" xml:lang=\"en\">\r\n<div class=\"titlepage\">\r\n<div>\r\n<div>\r\n<h4 class=\"title\"><a name=\"d0e512\" id=\r\n\"d0e512\"></a>5.3.2.&nbsp;TForm</h4>\r\n</div>\r\n</div>\r\n</div>\r\n<p>Creation of a database form with handler for submitting can be\r\nas simple as:</p>\r\n<pre class=\"programlisting\">\r\n$thefields=array(\"first_name\",\"last_name\",\"address\",\"phonenumber\");\r\n$this-&gt;forms[\"edit_addressbook_entry\"]=\r\n&amp;new TDBEditForm(\"addresbook\",\"edit_addressbook_info\",$thefields,\"mod_addressbook\",\"\",\"address_id\");\r\n</pre>\r\n<p>TModule just holds an array of instantiated forms. Each form has\r\na name, and methods that provide edit, submit etc. functionality.\r\nTModule just binds them together, and provides little functionality\r\nitself. The Action function is called by Catviz. There are virtual\r\nfunctions before_action and after_action provided. In particular\r\nafter_action is handy, it\'s a good place to create a custom block\r\nif you need one. If the action is \'form\', TModule will look at\r\nform_name and form_action and call the appropriate form. Each form\r\n\'knows\' the content variable for which it is creating content. Like\r\nTModule, TForm and it\'s descendants have an Action method which\r\nacts as a message/command dispatcher. All form objects are created\r\nbefore usage. They are contained in the session, so variables in\r\nthe forms are persistant throughout a session.</p>\r\n</div>\r\n</div>\r\n</div>\r\n<div class=\"sect1\" lang=\"en\" xml:lang=\"en\">\r\n<div class=\"titlepage\">\r\n<div>\r\n<div>\r\n<h2 class=\"title\" style=\"clear: both\"><a name=\"d0e520\" id=\r\n\"d0e520\"></a>6.&nbsp;Modules in the Catviz package</h2>\r\n</div>\r\n</div>\r\n</div>\r\n<div class=\"sect2\" lang=\"en\" xml:lang=\"en\">\r\n<div class=\"titlepage\">\r\n<div>\r\n<div>\r\n<h3 class=\"title\"><a name=\"d0e524\" id=\"d0e524\"></a>6.1.&nbsp;The\r\nWebpages module</h3>\r\n</div>\r\n</div>\r\n</div>\r\n<p>The webpages module provides a mechanism for maintaining and\r\ndisplaying webpages and blocks. Pages are structured in a tree\r\nstructure which is visualised by a DHTML/Javascript tree (using\r\ndTree by Geir Landro). The structure is created with a multi-admin\r\nand multi-usergroup scenario in mind. Typically, this is used in an\r\nIntranet environment where various persons/departments manage their\r\nown part of the site.</p>\r\n<p>In normal view, the tree shows all pages which are \'active\'\r\n(flag in mod_webpages) and which have a document_class for which\r\nyou have read rights.</p>\r\n<p>For someone who has webpages_user rights all inactive pages show\r\nas well. A webpages_user is in fact a webpage author. He can only\r\ncreate pages with a document_class for which he has write rights.\r\nThe parent page can only be a page of a class for which he has\r\nwrite rights. Sounds complicated? It simply comes down to the\r\nauthors administering their own tree.</p>\r\n<p>Users with webpages_admin rights can create root entries.</p>\r\n</div>\r\n</div>\r\n</div>',1,1,26,25,'Catviz Manual','2003-05-25','09:16:50',1,'');
INSERT INTO mod_webpages VALUES ('','','\r\nThe Catviz website is at <a title=\"Catviz\" href=\"http://www.catviz.org\">www.catviz.org</a>. <br />The Catviz website is hosted at <a title=\"SourceForge\" href=\"http://www.sf.net\">SourceForge</a>.<br /><br />You can contact me at joost <span style=\"font-weight: bold;\">at</span> catviz <span style=\"font-weight: bold;\">dot</span> org<br />\r\n',1,1,27,25,'Contact','2004-10-08','23:47:40',1,'contact');

##
## Table structure for table `mod_webpages_files`
##

CREATE TABLE mod_webpages_files (
  file_id int(11) NOT NULL auto_increment,
  file varchar(100) NOT NULL default '',
  webpage_id int(11) NOT NULL default '0',
  title varchar(50) NOT NULL default '',
  show_in_list tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (file_id)
) TYPE=MyISAM;

##
## Dumping data for table `mod_webpages_files`
##

INSERT INTO mod_webpages_files VALUES (1,'3eaaa20839b34_mini-joost.png',1,'mini-joost',0);
INSERT INTO mod_webpages_files VALUES (2,'3ec0031132cd8_controlpanel-screenshot.png',26,'Controlpanel screenshot',0);
INSERT INTO mod_webpages_files VALUES (3,'3ec0031cbdac4_menu-screenshot.png',26,'Menu screenshot',0);
INSERT INTO mod_webpages_files VALUES (4,'3ec002d874266_mini-joost.png',22,'J:)st',0);

##
## Table structure for table `registry`
##

CREATE TABLE registry (
  registry_value varchar(100) NOT NULL default '',
  registry_id int(11) NOT NULL auto_increment,
  module_id int(32) NOT NULL default '0',
  registry_section varchar(100) NOT NULL default '',
  registry_key varchar(32) NOT NULL default '',
  registry_type varchar(32) NOT NULL default '',
  registry_title varchar(50) NOT NULL default '',
  registry_help varchar(240) NOT NULL default '',
  registry_choices varchar(100) NOT NULL default '',
  PRIMARY KEY  (registry_id)
) TYPE=MyISAM;

##
## Dumping data for table `registry`
##

INSERT INTO registry VALUES ('www.catviz.org',1,0,'site_info','url','string','Site URL','This is the full URL of this site','');
INSERT INTO registry VALUES ('Catviz',2,0,'site_info','name','string','Name','The name of this site','');
INSERT INTO registry VALUES ('10',3,2,'main','max_failed_logins','string','Maximum number of failed logins','This is the maximum number of failed login attempts before the user is locked out','');
INSERT INTO registry VALUES ('30',4,2,'main','login_within_days','string','User should login within days','After account approval the user should login within this amount of days, otherwise the account will be disabled.','');
INSERT INTO registry VALUES ('3653',5,2,'main','default_expiry_date_days','string','Default expiry date days','The amount of days used as default account expiry','');
INSERT INTO registry VALUES ('1',6,0,'site_info','use_htmlarea','boolean','Use HTMLArea','<br />\r\n','');

