<?php
/**
* Catviz Approval Module
*
* Copyright (C) 2003 Joost Horward
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License 
* version 2 as published by the Free Software Foundation.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public License 
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330,
* Boston, MA 02111-1307 USA
* 
*
* The Approval module
* Modules interface to this module through the getApprovalItems method
* In the module that holds the content
*
* @package catviz
* @subpackage approval
* @author Joost Horward <joost@catviz.org>
* $Date: 2004/10/15 19:29:04 $
* $Author: joosth $
* $Log: mod_approval.php,v $
* Revision 1.8  2004/10/15 19:29:04  joosth
* Fixd bug that occurred when no user has approval_user rights
*
* Revision 1.7  2004/10/14 18:59:27  joosth
* Fixed bug in notification email query.
* Changed email to be template/themeable.
*
* Revision 1.6  2004/10/07 21:13:42  joosth
* Took forms out of modules and placed them in separate files - reduced module load time by 50%.
*
* Revision 1.5  2004/09/13 20:59:31  joosth
* Changed to GPL License
*
* Revision 1.4  2003/05/25 22:05:41  joosth
* Changed to be XHTML 1.0 compliant.
*
* Revision 1.3  2003/05/09 22:22:34  joosth
* Changed to use JIT Forms
*
* Revision 1.2  2003/04/29 21:34:41  joosth
* Added notification email function
*
* $Source: /cvsroot/catviz/catviz/mod/approval/php/mod_approval.php,v $
*/

/**
* Approval Module Class
*
* @package catviz
* @subpackage approval
* @author Joost Horward
* @see TModule
*/
class MOD_approval extends TModule{
    /**
    * Constructor for the News class
    *
    * @author Joost Horward
    * @param none
    * @return none
    */
    function MOD_approval(){
        TModule::TModule("approval","Approval");
    }
    
    /**
    * Assemble the content of the to be approved items list
    *
    * Query each module's getApprovalItems() method to get items which
    * need approval along with their links
    *
    * This method is called as a before_action_func of the 'admin' form
    * The effect is that the content of the form is created before each time
    * the form is shown.
    *
    * @param TForm &$theform The form on which this method is placed
    * 
    */
    function getApprovalContent(&$theform){
        foreach ($GLOBALS['modulenames'] as $modulename) {
            $results=$GLOBALS['module']["mod_$modulename"]->getApprovalItems();
            if ($results){
                $content .= "<b>Pending approvals from $modulename:</b><br />";
                foreach ($results as $result){
                    $content .= "<a href=\"{$result['url']}\">{$result['title']}</a><br />";
                    $content .= $result['summary'];
                    $content .='<br /><br />';
                }
                $content .="<br />";
            }
        }
        if ($content=="") { $content="There is nothing to approve"; };
        $theform->content=$content;     
    }
    /**
    * Send email to notify the arrival of new content to approval users
    */
    function sendNewContentNotification(){
    	$query="select mod_users.user_id as user_id,first_name,last_name,email from mod_users left join mod_users_acl using (user_id)  where mod_users_acl.access_class_name=\"approval_user\"";
        $result=runquery($query);
        while ($row= mysql_fetch_array($result)){
        	$user_id=$row['user_id'];
        	$mailaddresses[$user_id]=$row;
        }
    	$query="select mod_users.user_id as user_id,first_name,last_name,email from mod_users_group_acl left join mod_users_groupmember using (group_id) left join mod_users using(user_id) where mod_users_group_acl.access_class_name=\"approval_user\"";    	
        $result=runquery($query);
        while ($row= mysql_fetch_array($result)){
        	$user_id=$row['user_id'];
        	$mailaddresses[$user_id]=$row;
        }
		if ($mailaddresses){    	
	    	foreach($mailaddresses as $user_id=>$mailaddress){
	
					$this->first_name=$mailaddress['first_name'];
					$this->last_name=$mailaddress['last_name'];
					$this->email_address=$mailaddress['email'];
					$themename=$GLOBALS['theme'];
	
			        $filename=firstExistingFile("themes/$themename/mod/approval/templates/forms/new_content_email.txt","mod/approval/templates/new_content_email.txt");
			        // Note: $this is of course not a TForm.
			        // We cannot use the {} field tags in the template, only {!} and {*}		        
					$thetemplate=&new TTemplate(&$this,$filename);
					
					$thetemplate->clearContent();
					$thetemplate->processTag('subject','show');
					$subject=htmldecode($thetemplate->getContent());
					
					$thetemplate->clearContent();
					$thetemplate->processTag('to','show');
					$to_address=htmldecode($thetemplate->getContent());
	
					$thetemplate->clearContent();
					$thetemplate->processTag('from','show');
					$from_address=htmldecode($thetemplate->getContent());
					
					$thetemplate->clearContent();
					$thetemplate->processTag('email','show');
					$email=htmldecode($thetemplate->getContent());
					
					mail($this->email_address,$subject,stripslashes($email),$from_address);
	    	}
		}        
        
    }
}
?>
