<?php
/**
* Catviz Menu Manager Module
*
* Copyright (C) 2003 Joost Horward
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License 
* version 2 as published by the Free Software Foundation.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public License 
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330,
* Boston, MA 02111-1307 USA
* 
*
* This module allows editing the main menu
*
* @package catviz
* @subpackage menuman
* @author Joost Horward <joost@catviz.org>
* $Date: 2005/08/24 20:37:25 $
* $Author: joosth $
* $Log: mod_menu.php,v $
* Revision 1.8  2005/08/24 20:37:25  joosth
* Added JavaScript hover support to mod_menu
*
* Revision 1.6  2004/10/06 22:08:56  joosth
* Took forms out of modules and placed them in separate files - reduced module load time by 50%.
*
* Revision 1.5  2004/09/13 21:00:09  joosth
* Changed to GPL License
*
* Revision 1.4  2003/05/25 22:06:52  joosth
* Changed to be XHTML 1.0 compliant.
*
* Revision 1.3  2003/05/09 22:25:26  joosth
* Changed to JIT forms.
* Removed method_exists that could try to act on a non-object
*
* Revision 1.2  2003/04/29 21:40:09  joosth
* Added CVS headers
*
* $Source: /cvsroot/catviz/catviz/mod/menu/php/mod_menu.php,v $
*/

/**
* Menu & Menu admin Class
*
* @package catviz
* @subpackage menuman
* @author Joost Horward
* @see TModule
*/
class MOD_menu extends TModule{
    
    var $menuitems;
    /**
    * Constructor for the Module manager class
    *
    * @author Joost Horward
    * @param none
    * @return none
    */    

    function MOD_menu(){
        TModule::TModule("menu","Menu Manager");
        $this->menuitems=array();
        
        $sql_result=runquery("select menu_name,menu_item_title, menu_module,menu_op,menu_form,menu_action,menu_visible from mod_menu order by menu_order");
        while ($row = mysql_fetch_array($sql_result)) {
            $this->menuitems[$row['menu_name']]=$row;
        }
    }
    /**
    * afterAction()
    *
    * Build up the menu from the menu list each time (even if menu doesn't have focus)
    * Skips menu items to which the current user doesn't have access
    *
    */
    function afterAction(){
        global $module;
        global $theme;
        foreach ($this->menuitems as $menuname => $menuitem){
            $themodule='mod_' . $menuitem['menu_module'];
            $theform=$menuitem['menu_form'];
            $theop=$menuitem['menu_op'];
            $thetitle=$menuitem['menu_item_title'];
            $menuid=strtr($menuname,'_','-');
            if ($this->menuitems[$menuname]['menu_visible']){
                if($menuitem['menu_op']=='form'){
                    if (is_object($module[$themodule])) {
                        $form=&$module[$themodule]->form($theform);
                        if ($form){
                            if ($form->hasAccess("r")) {
                                $imagefilename= firstExistingFile("themes/$theme/mod_menu/$menuname.png","themes/$theme/mod/menu/img/$menuname.png");
                                if ($imagefilename!="") { 
                                	//$content .="<img height=\"32\" width=\"32\" src=\"$imagefilename\" align=\"middle\" hspace=\"10\" vspace=\"10\" alt=\"$menuname\" />";
                                };
                                $url=formURL($menuitem['menu_module'],$menuitem['menu_form'],$menuitem['menu_action'],'','r');
                                $content .= "<div class=\"menu-item-1\" id=\"menu-$menuid\" onmouseover=\"menuHover(this)\" onmouseout=\"menuUnHover(this)\" onclick=\"window.location='$url';\"><div><a href=\"$url\">{$menuitem['menu_item_title']}</a></div></div>";
                                //$content .= "<a href=\"index.php?module={$menuitem['menu_module']}&amp;{$menuitem['menu_module']}_op=form&amp;form_name={$menuitem['menu_form']}&amp;form_action={$menuitem['menu_action']}&amp;rootform=1\">{$menuitem['menu_item_title']}</a><br />";
                            }
                        }
                    }
                } else{
                    //$imagefilename= firstExistingFile("themes/$theme/mod_menu/$menuname.png","themes/$theme/mod/menu/img/$menuname.png");
                    //if ($imagefilename!="") { $content .="<img height=\"32\" width=\"32\" src=\"$imagefilename\" align=\"middle\" hspace=\"10\" vspace=\"10\" />";};
                    $url="index.php?module={$menuitem['menu_module']}&amp;{$menuitem['menu_module']}_op=$theop";
                    $content .= "<div class=\"menu-item-1\" id=\"menu-$menuid\" onmouseover=\"menuHover(this)\" onmouseout=\"menuUnHover(this)\" onclick=\"window.location='$url';\"><a href=\"$url\">$thetitle</a></div>";
                    //$content .= "<a href=\"$url">$thetitle</a><br />";
                }
            }
        }
        $GLOBALS['content']["CNT_menu"]=$content;
    }
    
    /**
    * Hide the menu item 'itemname'
    * @param string $itemname The name of the menu item to hide
    */    
    function menuHide($itemname){
        if ($this->menuitems[$itemname]!=""){
            $this->menuitems[$itemname]['menu_visible']=FALSE;
        }
    }

    /**
    * show the menu item 'itemname'
    * @param string $itemname The name of the menu item to show
    */    
    function menuShow($itemname){
        if ($this->menuitems[$itemname]!=""){        
            $this->menuitems[$itemname]['menu_visible']=TRUE;
        }
    }
    
    /**
    * Restart the session
    *
    * This allow a modified menu to take effect.
    * In effect it destroys the current session and starts again from index.php
    */
    function on_RestartSession(){
        session_destroy();    
        print "<HTML><META HTTP-EQUIV=\"refresh\" CONTENT=\"1; URL=index.php\"></HTML>";        
    }
}
?>
