<?php
/**
* Catviz Module Manager
*
*
* Copyright (C) 2003 Joost Horward
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License 
* version 2 as published by the Free Software Foundation.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public License 
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330,
* Boston, MA 02111-1307 USA
* 
*
* Module Manager for Catviz
* Add/Change/Remove modules
*
* @package catviz
* @subpackage moduleman
* @author Joost Horward <joost@catviz.org>
* $Date: 2005/03/28 08:20:12 $
* $Author: joosth $
* $Log: mod_moduleman.php,v $
* Revision 1.8  2005/03/28 08:20:12  joosth
* Changed controlpanel to be properly styled
*
* Revision 1.7  2004/10/06 22:26:34  joosth
* Added formURL function support
*
* Revision 1.6  2004/09/13 21:02:42  joosth
* Changed to GPL License
* Changed to use CSS for the controlpanel content
*
* Revision 1.5  2003/05/25 22:07:54  joosth
* Changed to be XHTML 1.0 compliant.
*
* Revision 1.4  2003/05/15 21:34:12  joosth
* Added detail table dependency between module table and access class table.
*
* Revision 1.3  2003/05/09 22:26:42  joosth
* Changed to use JIT Forms
*
* Revision 1.2  2003/04/29 22:01:37  joosth
* Added CVS headers
* corrected rights problem
*
* $Source: /cvsroot/catviz/catviz/mod/moduleman/php/mod_moduleman.php,v $
*/

/**
* Module Manager Class
*
* @package catviz
* @subpackage moduleman
* @author Joost Horward
* @see TModule
*/
class MOD_moduleman extends TModule{

    /**
    * Constructor for the Module manager class
    *
    * @param none
    * @return none
    */
    function MOD_moduleman(){
        TModule::TModule("moduleman","Module Manager");
    }
    
    /**
    * Create the content of the control panel
    * This function is called as the before_action_func
    *
    * @param TForm &$theform The form on which this method is placed
    */
    function getControlpanelContent(&$theform){

        foreach ($GLOBALS['modulenames'] as $modulename) {
            if (file_exists("mod/$modulename/img/controlpanel.png")) {
                $form=&$_SESSION['module']["mod_$modulename"]->form('admin');
                if ($form->hasAccess('r')){;
                	$url=formURL($modulename,'admin','edit');
                	$content .="<div><a href=\"$url\"><img hspace=\"10\" border=\"0\" src=\"mod/$modulename/img/controlpanel.png\" /></a><br /><a href=\"$url\" >{$form->title}</a></div>";
                    //$content .="<td class=\"controlpanel\"><a href=\"index.php?module=$modulename&amp;{$modulename}_op=form&amp;form_name=admin&amp;form_action=edit\"><img hspace=\"10\" border=\"0\" src=\"mod/$modulename/img/controlpanel.png\" /></a><br /></td>";
                    
                    $moduletitles[]=$form->title;
                }
            }
        }
/*        $content .="</tr><tr>";
        if ($moduletitles){
            foreach ($moduletitles as $moduletitle){
                $content .="<td class=\"controlpanel\">$moduletitle</td>";
            }
        }*/
        $theform->content="<div id=\"controlpanel\">$content</div>";
        
    }
}
?>
