<?php
/**
* Catviz News Module
*
* Copyright (C) 2003 Joost Horward
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License 
* version 2 as published by the Free Software Foundation.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public License 
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330,
* Boston, MA 02111-1307 USA
* 
*
* Provides news, news admin
* includes hooks for search and approve modules
*
* @package catviz
* @subpackage news
* @author Joost Horward <joost@catviz.org>
* $Date: 2005/08/24 20:38:37 $
* $Author: joosth $
* $Log: mod_news.php,v $
* Revision 1.11  2005/08/24 20:38:37  joosth
* Added parent_form parameter to form constructor calls
*
* Revision 1.10  2004/10/06 22:08:56  joosth
* Took forms out of modules and placed them in separate files - reduced module load time by 50%.
*
* Revision 1.9  2004/09/15 08:08:32  joosth
* Changed to GPL license (instead of LGPL)
* Removed TTemplateForm experiment
*
* Revision 1.8  2004/02/29 20:40:21  joosth
* Added edit icon to news view
*
* Revision 1.7  2003/10/11 21:31:40  joosth
* Enlarged textarea for HTMLArea
*
* Revision 1.6  2003/05/25 22:09:12  joosth
* Changed to be XHTML 1.0 compliant.
*
* Revision 1.5  2003/05/15 21:36:22  joosth
* Changed new article submit icon from the standard 'add' icon to it's own TIconLinkField
*
* Revision 1.4  2003/05/09 22:28:27  joosth
* Changed to use JIT Forms
* Fixed email sending on cancelled submission bug
*
* Revision 1.3  2003/04/30 20:17:23  joosth
* Changed to use TDocumentClassSelectorField and to only report to be approved items for which the user has th appropriate rights
*
* Revision 1.2  2003/04/29 22:07:06  joosth
* Added CVS headers
* Added email notification
* Added document rights support
*
* $Source: /cvsroot/catviz/catviz/mod/news/php/mod_news.php,v $
*/

/**
* News Class
*
* @package catviz
* @subpackage news
* @author Joost Horward
* @see TModule
*/
class MOD_news extends TModule{

    /**
    * Constructor for the News class
    *
    * @author Joost Horward
    * @param none
    * @return none
    */
    function MOD_news(){
        TModule::TModule("news","News");
    }
  
    
    /**
    * The Search hook
    */
    function search($searchstring,$limit=10){
        $allowed_document_classes=$GLOBALS['module']['mod_userman']->getDocumentReadClasses();
        $query = "select * from mod_news left join mod_users using (user_id) where (find_in_set(mod_news.document_class_id,\"$allowed_document_classes\")>0) and (subject like '%$searchstring%' or summary like '%$searchstring%' or bodytext like '%$searchstring%') and status='approved' limit $limit";                
        $sql_result=runquery($query);
        $index=1;
        while ($row = mysql_fetch_array($sql_result)) {
            $results[$index]['title']=$row['subject'];
            $results[$index]['summary']=$row['summary'];
            $results[$index]['url']="index.php?module=news&amp;news_op=form&amp;form_name=article&amp;form_action=show&amp;foreign_key_value={$row['news_id']}";
            $index++;
        }        
        return $results;
    }
    
    /**
    * The Approvals hook    
    */
    function getApprovalItems($limit=10){
        $allowed_document_classes=$GLOBALS['module']['mod_userman']->getDocumentReadClasses();
        $query = "select * from mod_news left join mod_users using (user_id) where (find_in_set(mod_news.document_class_id,\"$allowed_document_classes\")>0) and status='new' limit $limit";                
        $sql_result=runquery($query);
        $index=1;
        while ($row = mysql_fetch_array($sql_result)) {
            $results[$index]['title']=$row['subject'];
            $results[$index]['summary']=$row['summary'];
            $results[$index]['url']="index.php?module=news&amp;news_op=form&amp;form_name=news_item_approval&amp;form_action=edit&amp;foreign_key_value={$row['news_id']}";
            $index++;
        }        
        return $results;
    }
    /**
    * Notify the arrival of a new article
    * this is called as the after_action_func
    * @param TForm &$theform the form which is calling this function
    * @param string $theaction The action just performed by the form
    */
    function notifyNewArticle(&$theform,$theaction){    	
        if (($theaction=='submit') & (getButton()=="OK")){                   		
                $GLOBALS['module']['mod_approval']->sendNewContentNotification();            
        }
    }
}
?>
