<?php
/**
* Catviz Phonebook Module
*
* Copyright (C) 2003 Joost Horward
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License 
* version 2 as published by the Free Software Foundation.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public License 
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330,
* Boston, MA 02111-1307 USA
* 
*
* Simple phonebook with search
* includes hooks for search module
*
* @package catviz
* @subpackage phonebook
* @author Joost Horward <joost@catviz.org>
* $Date: 2004/10/10 12:20:18 $
* $Author: joosth $
* $Log: mod_phonebook.php,v $
* Revision 1.8  2004/10/10 12:20:18  joosth
* Added support for folded theme directory structure
*
* Revision 1.7  2004/10/08 18:13:51  joosth
* Took forms out of modules and placed them in separate files - reduced module load time by 50%.
*
* Revision 1.6  2004/09/13 21:03:20  joosth
* Changed to GPL License
*
* Revision 1.5  2003/05/25 22:13:34  joosth
* Changed to be XHTML 1.0 compliant.
*
* Revision 1.4  2003/05/15 21:37:49  joosth
* Made phonebook visible only to users with the  phonebook_user access class.
*
* Revision 1.3  2003/05/09 22:29:17  joosth
* Changed to use JIT Forms
*
* Revision 1.2  2003/04/29 22:10:58  joosth
* Major cleanup - got rid of the IM list
* Added CVS headers
*
* $Source: /cvsroot/catviz/catviz/mod/phonebook/php/mod_phonebook.php,v $
*/

/**
* Phonebook Class
* includes hooks for search module
*
* @package catviz
* @subpackage phonebook
* @author Joost Horward
* @see TModule
*/
class MOD_phonebook extends TModule{
    var $searchstring;

    /**
    * Constructor for the phonebook class
    *
    * @author Joost Horward
    * @param none
    * @return none
    */
    function MOD_phonebook(){
        TModule::TModule("phonebook");
    }    

    /**
    * Create the search block
    *
    * This function overrides the after_action of TModule
    * and creates the search block the 'old' way
    *
    */
    function afterAction(){
        global $theme;
        if (hasAccessClass('phonebook_user')){
            $searchbutton=firstExistingFile("themes/$theme/mod_phonebook/search.png","themes/$theme/mod/phonebook/img/search.png");
            $content = "<form name=\"Phonebook\" method=\"post\" action=\"index.php\"><table class=\"tform-layout\" cellspacing=\"0\" cellpadding=\"0\"><tr><td><input type=\"text\" name=\"searchstring\" class=\"tform-layout\" value=\"$this->searchstring\" /></td><td><input value=\"Search!\" name=\"woof\" type=\"image\" align=\"middle\" src=\"$searchbutton\" /></td></tr></table>";
            $content .= "<input type=\"hidden\" name=\"module\" value=\"phonebook\" />";
            $content .= "<input type=\"hidden\" name=\"phonebook_op\" value=\"search\" />";
            $content .= "</form>";
            $GLOBALS['content']["CNT_phonebook"]="<table width=\"100%\" border=\"0\" cellspacing=\"1\" class=\"mod-layout\"><tr><th class=\"mod-layout\">Phone Book Search</th></tr><tr><td class=\"mod-layout\">$content</td></tr></table>";
        }
    }

    /**
    * Perform a phonebook search and show a list of results
    */
    function on_Search() {
        $this->searchstring=$_REQUEST['searchstring'];
        $thequery = "select * from mod_phonebook where last_name like '%$this->searchstring%' or first_name like '%$this->searchstring%' or department like '%$this->searchstring%' or extension = '$this->searchstring' order by last_name limit 20";
        $form=&$this->form('phone_list');
        $form->query=$thequery;
        $_SESSION['stack']->push(array("phonebook","phone_list","show"));        
        $form->action("show");
    }
   
    /**
    * Search Hook
    * with max. '$limit' rows
    * tags: title, summary, url
    */    
    function search($searchstring,$limit=10){
        $query = "select * from mod_phonebook where last_name like '%$searchstring%' or first_name like '%$searchstring%' or department like '%$searchstring%' or extension = '$searchstring' order by last_name limit $limit";
                
        $sql_result=runquery($query);
        $index=1;
        while ($row = mysql_fetch_array($sql_result)) {
            $results[$index]['title']="{$row['first_name']} {$row['last_name']}";
            $results[$index]['summary']="{$row['first_name']} {$row['last_name']} - {$row['department']} Ext. {$row['extension']}";
            $results[$index]['url']="index.php?module=phonebook&amp;phonebook_op=form&amp;form_name=phonebook&amp;form_action=show&amp;foreign_key_value={$row['phonebook_id']}";
            $index++;
        }        
        return $results;
    }   
}
?>
