<?php
/**
* Catviz Site Search
*
* Copyright (C) 2003 Joost Horward
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License 
* version 2 as published by the Free Software Foundation.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public License 
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330,
* Boston, MA 02111-1307 USA
* 
*
* Provides site search function
* requires search hook in each module that wants to
* support Search [module description]
*
* @package catviz
* @subpackage search
* @author Joost Horward <joost@catviz.org>
* $Date: 2005/03/28 16:08:48 $
* $Author: joosth $
* $Log: mod_search.php,v $
* Revision 1.7  2005/03/28 16:08:48  joosth
* Changed search box to non-tables CSS styleable
*
* Revision 1.6  2004/10/06 22:08:55  joosth
* Took forms out of modules and placed them in separate files - reduced module load time by 50%.
*
* Revision 1.5  2004/09/15 08:17:17  joosth
* Changed to GPL license (instead of LGPL)
* Changed CSS style of Search form
*
* Revision 1.4  2003/05/25 22:14:17  joosth
* Changed to be XHTML 1.0 compliant.
*
* Revision 1.3  2003/05/09 22:30:14  joosth
* Changed to use JIT Forms
*
* Revision 1.2  2003/04/29 22:14:29  joosth
* Added CVS headers
* Make search term bold in result
* Keep search term in input box
*
* $Source: /cvsroot/catviz/catviz/mod/search/php/mod_search.php,v $
*/

/**
* Site Search Class
*
* @package catviz
* @subpackage search
* @author Joost Horward <joost.horward@btopenworld.com>
* @see TModule
*/
class MOD_search extends TModule{
    /**
    * @var string  The current search string
    */
    var $searchstring;
    
    /**
    * Constructor for the Search class
    *
    * @param none
    * @return none
    */

    function MOD_search(){
        TModule::TModule("search");
    }
  
    /**
    * Performs the actual search
    * Query each module&put results in searchresult form
    */
    function on_Search(){
        $searchstring=$_REQUEST['searchstring'];
        $this->searchstring=$searchstring;
        foreach ($GLOBALS['modulenames'] as $modulename) {
            $results=$GLOBALS['module']["mod_$modulename"]->search($searchstring);
            if ($results){
                $content .= "<b>Gevonden in $modulename:</b><br />";
                foreach ($results as $result){
                    $thetitle=preg_replace("/$searchstring/i","<b>\$0</b>",$result['title']);
                    $content .= "<a href=\"{$result['url']}\">$thetitle</a><br />";
                    $summary=$result['summary'];
                    $summary=preg_replace("/$searchstring/i","<b>\$0</b>",$summary);
                    $content .= $summary;
                    $content .='<br /><br />';
                }
                $content .="<br />";
            }
        }
        if ($content=="") { $content="Er werden geen resultaten gevonden voor \"$searchstring\"."; };
        $form=&$this->form('searchresult');
        $form->content=$content;
        $form->action('show');
    }
    
    /**
    * Create the search block
    *
    * This function overrides the after_action of TModule
    * and creates the search block the 'old' way
    *
    */
    function afterAction(){
        global $theme;
        $searchbutton=firstExistingFile("themes/$theme/mod_search/search.png","themes/$theme/mod/search/img/search.png");
        $content = "<form  name=\"Search\" method=\"post\" action=\"index.php\">";
        $content .="<input type=\"text\" size=\"18\" name=\"searchstring\" class=\"mod-layout\" value=\"$this->searchstring\" />";
        $content .="<input value=\"Search!\" name=\"woof\" type=\"image\" align=\"middle\" src=\"$searchbutton\" />";
        $content .= "<input type=\"hidden\" name=\"module\" value=\"search\" />";
        $content .= "<input type=\"hidden\" name=\"search_op\" value=\"search\" />";
        $content .= "</form>";
        $GLOBALS['content']["CNT_search"]="<h1 id=\"search-head\" class=\"box\">Search</h1><div id=\"search-body\" class=\"mod-layout\">$content</div>";
    }
}
?>
