<?php
/**
* Catviz Registry Editor Module
*
* Copyright (C) 2003 Joost Horward
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License 
* version 2 as published by the Free Software Foundation.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public License 
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330,
* Boston, MA 02111-1307 USA
* 
*
* Provides a statistics module for Catviz
*
* @package catviz
* @subpackage stats
* @author Joost Horward <joost@catviz.org>
* $Date$
* $Author$
* $Log$
* $Source$
*/

/**
* TStatGraphField Class
* @package catviz
* @subpackage stats
* @author Joost Horward
*/
class TStatGraphField extends TField{
	var $width,$height,$start_date,$end_date,$items,$year,$month;
	/**
	* 
	*/
	function TStatGraphField (&$theform,$thename,$thetitle="",$theattributes="",$thewidth,$theheight) {
	    $this->TField($theform,$thename,$thetitle,"statgraph",1,'',$theattribs);
		$this->width=$thewidth;
		$this->height=$theheight;
		$this->new_visitor=1;
	}
	
	function on_Show(){
		$reqform=$this->form->module->form('graph_req');
		$month=$reqform->fields['month']->getValue();
		$year=$reqform->fields['year']->getValue();
		$items=$reqform->fields['stats']->getValue();
		//echo "The month is $month; the year is $year; the items are $items;";
		$value="<img width={$this->width} height={$this->height} src=\"mod/stats/php/statgraph.php?width={$this->width}&height={$this->height}&month=$month&year=$year&items=$items\" alt=\"statistic graph\" class=\"{$this->form->style}\" align=\"left\" />";
    	return ($value);
	}
	
	function on_Edit(){	
        return($this->on_Show($value));
    }
}
/**
* Statistics Class
*
* @package catviz
* @subpackage stats
* @author Joost Horward
* @see TModule
*/
class MOD_stats extends TModule{
	var $new_visitor=1;
    /**
    * Constructor for the Statistics module class
    *
    * @author Joost Horward
    * @param none
    * @return none
    */
    function MOD_stats(){
        TModule::TModule("stats","Statistics");
        $this->new_visitor=1;
    }
    
	/**
	* This function is called when the graph_show form is being prepared.
	* It simply gets the values from the request form and passes them on to 
	* the graph field object
	*/
	
    
	/**
	* Record a statistic value
	* If the value is not given a counter type is assumed (eg the stat gets incremented)
	* If the value is given it will override the statistic for that category/day
	*/    
    function recordStat($name,$category="",$value=""){
    	//print "Recording statistics: name : $name category: $category value : $value <br />";
    	// obtain the date. It's important to 'freeze' the date we are working with - imagine this
    	// procedure to be run a few milliseconds before midnight...    	
		//print "Recording statistic $name $category $value <br />";
		$category=addslashes(substr($category,0,255));
    	$date=date("Y-m-d");
    	// obtain stat_id
    	$result=runQuery("select stat_id from mod_stats where stat_name=\"$name\"");
    	$row=mysql_fetch_array($result);
    	if ($row) {
    		$stat_id=$row['stat_id'];
    	
    		// See if stat_id,stat_category has already been recorded today
    		$result=runQuery("select stat_record_id,stat_record_value from mod_stats_records where stat_id=\"$stat_id\" and stat_record_category=\"$category\" and stat_record_date=\"$date\"");
    		$row=mysql_fetch_array($result);
    		if ($row){    		
    			$stat_record_id=$row['stat_record_id'];
    			if ($value) {
    				runQuery("update mod_stats_records set stat_record_value=$value where stat_record_id=$stat_record_id");
    			} else {
    				runQuery("update mod_stats_records set stat_record_value=stat_record_value+1 where stat_record_id=$stat_record_id");
    			}
    		}else{
    			if ($value){
    				runQuery("insert mod_stats_records set stat_id=$stat_id,stat_record_value=$value,stat_record_category=\"$category\",stat_record_date=\"$date\"");
    			}else{
    				runQuery("insert mod_stats_records set stat_id=$stat_id,stat_record_value=1,stat_record_category=\"$category\",stat_record_date=\"$date\"");
    			}
    		}	    	
    	}
    }
    
	/**
	* Record number of visitors and hits
	* This is the only statistic that is automatically provided by the module
	* All others need to call recordStat themselves
	*/
    function action($thefunction){
    	$this->recordStat('site_hits');
  		$this->recordStat('site_module',$GLOBALS['req_module']);
    	if ($this->new_visitor==1) {
    		$this->recordStat('site_visitors');
    		$this->recordStat('site_ip',$_SERVER['REMOTE_ADDR']);
    		$this->recordStat('site_referer',$_SERVER['HTTP_REFERER']);
    		$this->recordStat('site_user_agent',$_SERVER['HTTP_USER_AGENT']);
    		$this->new_visitor=0;
    	}    	
    	return parent::action($thefunction);
    }
    
}
?>
