<?php
/**
* Catviz Webpages Module
*
* Copyright (C) 2003 Joost Horward
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License 
* version 2 as published by the Free Software Foundation.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public License 
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330,
* Boston, MA 02111-1307 USA
* 
*
* Provides static web pages
* 
*
* @package catviz
* @subpackage webpages
* @author Joost Horward <joost@catviz.org>
* $Date: 2005/08/24 20:38:37 $
* $Author: joosth $
* $Log: mod_webpages.php,v $
* Revision 1.13  2005/08/24 20:38:37  joosth
* Added parent_form parameter to form constructor calls
*
* Revision 1.11  2004/10/14 19:10:01  joosth
* Changed TWebPage 'This page is empty' into 'This page is empty or does not exist'
*
* Revision 1.10  2004/10/06 22:08:53  joosth
* Took forms out of modules and placed them in separate files - reduced module load time by 50%.
*
* Revision 1.9  2004/09/15 08:23:47  joosth
* Changed to GPL license (instead of LGPL)
* Moved TWebpageSelector to catviz_lib
* Support for external URLs
*
* Revision 1.8  2004/02/29 20:50:39  joosth
* use TTabbedMultiForm in webpage editor
* use HTMLarea in webpage editor
*
* Revision 1.7  2003/10/11 20:02:36  joosth
* changed TWebpageSelectorField to use
*
* Revision 1.6  2003/07/21 21:21:28  joosth
* Added active only filter
*
* Revision 1.5  2003/06/15 21:20:59  joosth
* Added ordering in webpages list
*
* Revision 1.4  2003/05/25 22:14:17  joosth
* Changed to be XHTML 1.0 compliant.
*
* Revision 1.3  2003/05/15 21:50:55  joosth
* TWebpageSelector constructor bug ($theattrib default) fixed. Added non option for TWebpageSelectorField. Changed root webpage to be edited by webpage_admin users (was only admins).
*
* Revision 1.2  2003/05/09 22:33:16  joosth
* Changed to use JIT Forms
*
* Revision 1.1  2003/04/29 22:25:57  joosth
* Initial add of webpages module
*
* $Source: /cvsroot/catviz/catviz/mod/webpages/php/mod_webpages.php,v $
*/

class TWebPageForm extends TTabbedMultiForm{
    var $filenames;
    var $file_list_form;
    
    function TWebPageForm (&$themodule,$form_name,$thetitle,&$theforms,$theattributes,$the_parent_form_name="",$thekeyfield="id",&$file_list_form){
          $this->TTabbedMultiForm ($themodule,$form_name,$thetitle,$theforms,$theattributes,$the_parent_form_name,$thekeyfield);
          $this->file_list_form=&$file_list_form;
    }
    
    function action($form_action){    	
    	
    	if($form_action=='') $form_action='webpage';
    	parent::action($form_action);
    }
        
    /**
    * Action in response to show message
    *
    * Builds an edit form based on previously stored form info
    * Like On_edit but less complicated as there is no info to save in the form
    */
    function on_Webpage(){
    	if (!($this->foreign_key_value>0)) {
        	$query="select webpage_id from mod_webpages where webpage_name=\"$this->foreign_key_value\"";
           	$zresult=runQuery($query);
           	if ($zrow=mysql_fetch_array($zresult)){
            	$this->foreign_key_value=$zrow['webpage_id'];
           	}        

        }
        $query="select * from mod_webpages_files where webpage_id=$this->foreign_key_value";
        $fresult=runquery($query);
        while ($frow= mysql_fetch_array($fresult)){
            $fname=$frow['file'];
            $filenames[]=$fname;
            if ($frow['show_in_list']){
                $title[$fname]=$frow['title'];
            }
        }
        if ($this->foreign_key_value>0) {
        	$query="select title,html,document_class_id,url from mod_webpages where webpage_id=$this->foreign_key_value";
        }else{
        	$query="select title,html,document_class_id,url from mod_webpages where webpage_name=\"$this->foreign_key_value\"";
        }
        $result=runquery($query);
        $this->row = mysql_fetch_array($result);        
        $allowed_doc=$GLOBALS['module']['mod_userman']->hasDocumentReadClass($this->row['document_class_id']);
        if ($allowed_doc){
            $content = $this->prologue;
            $url=$this->row['url'];
            if ($url) {
            	$html_array=file($url);
            	foreach ($html_array as $html_line) { 
            		$html .= $html_line ;
            	}
            }else{
	            $html=$this->row['html'];
	            if ($filenames){
	                foreach($filenames as $filename){                
	                    $original_filename=substr(strstr($filename,'_'),1);                
	                    $new_filename="var/mod/{$this->module->name}/file/$filename";
	                    $html=str_replace("\"$original_filename\"","\"$new_filename\"",$html);
	                    $atitle=$title[$filename];
	                    if ($atitle){
	                        $filelist_content .="<a href=\"var/mod/{$this->module->name}/file/$filename\" title=\"$original_filename\">$atitle</a><br />";
	                    }
	                }
	            }
            }
            if ($this->file_list_form) { $this->file_list_form->content=$filelist_content;};
            $content .= $html;
            $content .= $this->epilogue;
            if ($content=="") {$content="This page is empty or does not exist.";}
            $this->content=$content;
            if ($GLOBALS['module']['mod_userman']->hasDocumentWriteClass($this->row['document_class_id'])){
                $this->actionbar_content=$this->getActionBar();
            }else{             
                $this->actionbar_content="";
            }
            $this->title=$this->row['title'];
        } else{
            $this->content="Access denied.";
        }        
    }
}

class TStaticWebpageForm extends TDBForm{
    function TStaticWebpageForm(&$themodule,$form_name,$thetitle,$the_foreign_key_name="",$theattributes="s",$thekeyfield="id"){
        $this->TDBForm(&$themodule,$form_name,$thetitle,$the_foreign_key_name,$theattributes,"",$thekeyfield);
    }
    
    // Prevent translation of static forms
    function translate()
    {
    }
    function on_Show(){

        $query="select title,html,document_class_id from mod_webpages where content_var=\"$this->contentvar\" and active";
        $result=runquery($query);
        $this->row = mysql_fetch_array($result);
        $allowed_doc=$GLOBALS['module']['mod_userman']->hasDocumentReadClass($this->row['document_class_id']);        
        if ($allowed_doc){
            $content = $this->prologue;            
            $html=$this->row['html'];

            $content .= $html;
            $content .= $this->epilogue;
            $this->content=$content;
            $this->actionbar_content=$this->getActionBar();
            $this->title=$this->row['title'];
        } else{
            $this->content="";
        }        
    }
    
}

/**
* Webpages Class
*
* @package catviz
* @subpackage webpages
* @author Joost Horward
* @see TModule
*/
class MOD_webpages extends TModule{
    /**
    * Constructor for the News class
    *
    * @author Joost Horward
    * @param none
    * @return none
    */

    function MOD_webpages(){
        TModule::TModule("webpages","Webpages");
    }
    /**
    * Override TModule's InitializeForms()
    * Should intialize the forms
    * Is called at init time and every time the user changes
    */
    
    function initializeForms() {
        TModule::InitializeForms();
        /*
        // The pages tree
        $this->form('tree');
        
        // The filelist box
        $this->form('webpages_filelist');
        
        /*
        * Static pages
        
        $query="select title,content_var from mod_webpages where (content_var<>\"\") and active";
        $result=runquery($query);
        while ($row= mysql_fetch_array($result)){
            $content_var=$row['content_var'];
            $this->forms[$content_var]=&new TStaticWebpageForm($this,$content_var,$row['title'],'','s','');
            $this->forms[$content_var]->contentvar=$content_var;
            $this->forms[$content_var]->setACL("r","rw","rw");
        }*/
    }
    
    /**
    * The Search hook
    */
    function search($searchstring,$limit=10){
        $allowed_document_classes=$GLOBALS['module']['mod_userman']->getDocumentReadClasses();
        $query="select * from mod_webpages left join mod_users using (user_id) left join mod_users_document_class on (mod_webpages.document_class_id=mod_users_document_class.document_class_id) where find_in_set(mod_webpages.document_class_id,\"$allowed_document_classes\")>0 and (title like '%$searchstring%' or html like '%$searchstring%') and active limit $limit";        

        $sql_result=runquery($query);
        $index=1;
        while ($row = mysql_fetch_array($sql_result)) {
            $results[$index]['title']=strip_tags($row['title']);
            $text=strip_tags($row['html']);
            if ($searchstring){
                $p=strpos(strtoupper($text),strtoupper($searchstring));
            } else {
                $p=0;
            }
            $p=$p-50; if ($p<0) {$p=0;};
            $summary=substr($text,$p,100);
            $results[$index]['summary']=$summary;
            $results[$index]['url']="index.php?module=webpages&webpages_op=form&amp;form_name=webpage_multi_edit&amp;form_action=webpage&amp;foreign_key_value={$row['webpage_id']}";
            $index++;
        }        
        return $results;
    }
    
    function beforeAction(){
       // The pages tree
        $this->form('tree');
        
        // The filelist box
        $this->form('webpages_filelist');
        
        /*
        * Static pages
        */
        $query="select title,content_var from mod_webpages where (content_var<>\"\") and active";
        $result=runquery($query);
        while ($row= mysql_fetch_array($result)){
            $content_var=$row['content_var'];
            $this->forms[$content_var]=&new TStaticWebpageForm($this,$content_var,$row['title'],'','sv','');
            $this->forms[$content_var]->contentvar=$content_var;
            $this->forms[$content_var]->setACL("r","rw","rw");
        }
    }
    
    
    /**
    * post-process a webpage that is being submitted
    * this is called as the after_action_func
    * @param TForm &$theform the form which is calling this function
    * @param string $theaction The action just performed by the form
    */
    function beforeWebpageSubmit(&$theform,$theaction){
    	//echo "The action is $theaction<br>";
        if ($theaction=='submit'){
        	$html=$theform->fields['html']->getValue();        	            
            //echo "Hey! you are saving a webpage!";
            $html= stripslashes($html);
            
            /*
            * Build filelist
            */
            
            $query="select * from mod_webpages_files where webpage_id=$theform->foreign_key_value";
        	$fresult=runquery($query);
        	while ($frow= mysql_fetch_array($fresult)){
            	$fname=$frow['file'];
            	$filenames[]=$fname;
            	if ($frow['show_in_list']){
                	$title[$fname]=$frow['title'];
            	}
        	}
        	        
            if ($filenames){
                foreach($filenames as $filename){                
                    $original_filename=substr(strstr($filename,'_'),1);                
                    $new_filename="var/mod/{$this->name}/file/$filename";
                    //print "Replacing $original_filename with $new_filename <br>";
                    $html=str_replace("\"$original_filename\"","\"$new_filename\"",$html);
                    $html=str_replace("/$original_filename\"","/$new_filename\"",$html);
                    $atitle=$title[$filename];
                    if ($atitle){
                        $filelist_content .="<a href=\"var/mod/{$this->module->name}/file/$filename\" title=\"$original_filename\">$atitle</a><br />";
                    }
                }
            }
            $theform->fields['html']->setValue(addslashes($html));
            //print $html;
        }
    }
}
?>
